// YAServerDlg.h : ͷļ
#pragma once
#include "afxwin.h"
#include "resource.h"
#include "structdef.h"
#include "constdef.h"
#include "def_msg.h"
#include "socketdef.h"
#include "ReportCtrl/ReportCtrl.h"
#include <sio_client.h>
#include "../thirdparty/include/iocp/Src/TcpServer.h"
#include "../thirdparty/include/iocp/Global/helper.h"
#include "afxcmn.h"
#include "./SyncTime/SyncManager.h"
#include "classdef.h"
#include "QueueStrManager.h"
#include "uwb_msg_def.h"
#include <json/json.h>
#include "MysqlConnPool.h"
#include "carManager.h"
#include "./MysqlConnectPool/CDBConnPool.h"

struct area;
struct point_2;

extern BOOL m_log_sys_status;

//using namespace sio;
using namespace std;
using namespace HostServer;

struct  _SLS // system_limit_setting
{
	unsigned int over_count_person; // ԱԱ
	unsigned int over_count_vehicle; // ³Ա
	unsigned int over_time_person; // Աʱ
	unsigned int over_time_vehicle; // ³ʱ
	double over_speed; // ³

	// lihongzhen  2017/8/18 ƫʱ
	int att_starttime_offset_staff;
	int att_endtime_offset_staff;
	int att_starttime_offset_vehicle;
	int att_endtime_offset_vehicle; 
	uint64_t att_person_thre_hour;
	//׷β
	double rear_end_d;
	time_t rear_end_t;
	double geofault_warn_dis;
};

struct _DBS // db setting
{
	string host;
	string user;
	string password;
	string dbname;
	string encoding;
	int port;
};
struct ReaderInfo_
{
	int state; // 0 
	DWORD reader_id; // վ
	DEVICE_TYPE reader_type; // ͨŷվվ
};
struct SpecialCard
{
	std::map<int,std::vector<int>> m_map;
	void insert(int areaid,int cardid)
	{
		auto it = m_map.find(areaid);
		if (it == m_map.end())
		{
			std::vector<int> tmp;
			tmp.push_back(cardid);
			m_map.insert(std::make_pair(areaid,tmp));
		}
		else
		{
			auto iter = std::find(it->second.begin(),it->second.end(),cardid);
			if (iter == std::end(it->second))
				it->second.push_back(cardid);
		}
	}
	bool find(int areaid,int cardid)
	{
		auto it = m_map.find(areaid);
		if (it == m_map.end())
			return true;
		else
		{
			auto iter = std::find(it->second.begin(),it->second.end(),cardid);
			if (iter == std::end(it->second))
				return false;
		}
		return true;
	}
	std::string to_str()
	{
		std::stringstream ss;
		for(const auto s:m_map)
		{
			ss<<"areaId:"<<s.first<<'{';
			for (const auto x:s.second)
			{
				ss<<x<<",";
			}
			ss<<"}";
		}
		return std::move(ss.str());
	}
};
struct _SOCK
{
	CString sip;
	CONNID dwConnID;
	//int state; // 0 
	//DWORD reader_id; // վ
	//DEVICE_TYPE reader_type; // ͨŷվվ
	std::list<ReaderInfo_> m_reader;
	bool findReader(DWORD readerId)
	{
		bool b = false;
		for (const auto & r :m_reader)
		{
			if (r.reader_id == readerId)
			{
				b = true;
				break;
			}
		}
		return b;
	}
	ReaderInfo_ & get(DWORD readerId)
	{
		auto it = std::find_if(m_reader.begin(),m_reader.end(),[readerId](const ReaderInfo_ & r){
			if (r.reader_id == readerId)
				return true;
			else
			{
				return false;
			}
		});
		return *it;
	}
};

struct _SOCKET_BUFFER
{
	CONNID dwConnID;
	BYTE pData[LENGTH_MSG_1M]; 
	WORD wLen;
	WORD wReadLen;

	_SOCKET_BUFFER(){
		dwConnID = 0;
		wLen = 0;
		wReadLen = 0;
		memset(pData,0,LENGTH_MSG_1M*sizeof(BYTE));
	}
};

//extern DWORD WINAPI _exec_sql(LPVOID lparam);
extern DWORD WINAPI _exec_sql(const char* lparam);

// CYAServerDlg Ի
class CYAServerDlg : public CDialogEx, public CTcpServerListener
{
	typedef map<string, std::shared_ptr<Card>> CardMap;
	typedef map<CString, std::shared_ptr<_SOCK>> SocketMap;
	typedef map<CString, std::shared_ptr<_SOCKET_BUFFER>> SocketBufferMap;
	typedef map<INT64, std::shared_ptr<YaEvent>> EventMap;
	typedef map<int, std::shared_ptr<LightCallInfo>> LightCallMap;

	typedef map<int, std::shared_ptr<area>> Area_Map; //lemon 2017/11/20

	struct LogMsg
	{
		CString strFile;
		CString strLog;
		bool isNeedTime;
	};
	struct DataMsg
	{
		CONNID dwConnID;
		int iLength;
		BYTE* pData;		
	};
	// 
public:
	CYAServerDlg(CWnd* pParent = NULL);	// ׼캯
	~CYAServerDlg();
	// Ի
	enum { IDD = IDD_YASERVER_DIALOG };
	void uwb_alarm(std::map<uint64_t,std::string>&m2,bool flag,std::shared_ptr<NAMESPACE_POINT::card_interface>c);
	void uwb_putDb(std::vector<std::string> &v);
	void record_staff_count(int num);
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ֧
private:
	//---lemon smooth----
	NAMESPACE_POINT::CarManager * m_carmanage;
	std::unique_ptr<std::thread> m_Pthread;
	void run();
	void run_sensor();
	bool m_bStop;
	time_t time_interval;
	SpecialCard m_sc;
	struct vInfo
	{
		vInfo()
		{
			is_alarm=false;
			real_end_start_time=0;
			backfired_start_time=0;
		}
		void push(const std::string & c1, const std::string &c2)
		{
			m_cid[0]=c1;
			m_cid[1]=c2;
			std::sort(m_cid.begin(),m_cid.end());
		}
		std::string getKey() const
		{
			return m_cid[0]+"&"+m_cid[1];
		}
		bool is_alarm;
		std::array<std::string,2> m_cid;
		time_t real_end_start_time ;
		time_t backfired_start_time;
	};
	std::map<std::string,vInfo> m_CloserVehicle;
	//---lemon smooth----
	virtual EnHandleResult OnPrepareListen(ITcpServer* pSender, SOCKET soListen);
	virtual EnHandleResult OnAccept(ITcpServer* pSender, CONNID dwConnID, SOCKET soClient);
	virtual EnHandleResult OnSend(ITcpServer* pSender, CONNID dwConnID, const BYTE* pData, int iLength);
	virtual EnHandleResult OnReceive(ITcpServer* pSender, CONNID dwConnID, const BYTE* pData, int iLength);
	virtual EnHandleResult OnClose(ITcpServer* pSender, CONNID dwConnID, EnSocketOperation enOperation, int iErrorCode);
	virtual EnHandleResult OnShutdown(ITcpServer* pSender);
	virtual void OnReConnect(unsigned, unsigned);
	// ʵ
protected:
	HICON m_hIcon;

	// ɵϢӳ亯
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CButton m_btStart;
	CButton m_btStop;
	CMenu m_mnMain;
	afx_msg LRESULT on_monitor(WPARAM wParam, LPARAM lParam);
	afx_msg void OnBnStop();
	afx_msg void OnBnStart();	
	afx_msg void OnBnExit();
	afx_msg void OnBnSyncTime();
	afx_msg void OnMenuDb();
	afx_msg void OnMenuLog();
	afx_msg void OnMenuParam();
	afx_msg void OnBnCallHisData();
public: 
	// ui operation
	CTcpServer _server; // socket serverշվ
	HostServer::SyncManager syncmanager; // ʱͬ
	EnAppState m_enState; // ϵͳ״̬ƽ水ť״̬
	CRITICAL_SECTION m_csRemoveSocket;
	CRITICAL_SECTION m_csRefreshList;
	CRITICAL_SECTION m_csParseDataServer;
	CRITICAL_SECTION m_csSyncTime;
	CRITICAL_SECTION m_csCallInfo;
	CRITICAL_SECTION m_csHandUp;
	CRITICAL_SECTION m_csAreaList;
	CRITICAL_SECTION m_MC_Lock;
	CRITICAL_SECTION m_csCoalDrvingFaceList;
	QueueStrManager* m_qsmSQL;

	bool is_start_tcp;
	void set_app_state(EnAppState eas);
	void start_tcp_server(); 
	void stop_tcp_server();	
public:
	CString m_strConncetion; // ݿַ
	int m_nPort; // ˿
	int m_nCountClick;

	YADB::_DB_POOL_SETTING_ m_DBSetting; //ݿ

	CWinThread* m_thread_monitor; // سͨ߳
	CWinThread* m_thread_timer; // timeṛ߳UỊ߳ʹontimer
	unsigned int m_uint_state; // ɼ״̬
	// bit 0, ״̬л߹ر
	// bit 1, ɼ״̬쳣
	// bit 2, վ״̬жϻû
	// bit 3, websocket״̬δ
	// bit 4, ݿ״̬δ
	time_t m_time_last_rec; // յվݵʱ
	bool is_websocket_ok;  // websocket ״̬
	bool is_websocket_login; // websocket¼״̬
	// web
	bool is_websocket_login_ex;
	bool is_websocket_ok_ex;

	bool is_server_ok;  // tcp server ״̬
	bool is_database_ok;  // ݿ״̬

	int m_shift_id; // ǰ
	BOOL m_bUseFilter; // Ƿʹ˲

	int m_nFilterType; // ˲,ǰҪΪ˲
	int m_nMallocTimes; // 

	//BOOL m_log_sys_status;
	// ־أǷ־
	BOOL m_log_raw_data;  // ԭʼ16
	BOOL m_log_parse_data; // ԭʼݣ10
	BOOL m_log_send_package; // web˷͵json
	BOOL m_log_recv_package; // web˵json
	BOOL m_log_locate_data; // λĿݡĶλ㷨еĽ

	SocketMap mp_socket_list; // ӵsocketбӵķվб
	SocketBufferMap mp_socket_buffer_list; // socketݰƬб

	ReaderMap mp_reader_list; // зվ
	ReaderMap mp_ctrl_reader_list; // пƷվ
	AreaMap mp_area_list; // 
	BigSmallReaderMap mp_bigsmall_reader_list;	//Сվϵ
	DrivingfaceWarningPointMap mp_drivingface_warning_point_list; // 澯б
	DrivingfaceWarningPointMapAll mp_drivingface_warning_point_list_all;//澯ȫб
	//ʶϲ澯
	WarningPoint_Map m_WarningPoint_list;

	SpecilaAreaEntryMap mp_special_area_entry_list; //
	DrivingfaceRenderMap mp_driving_face_render_list; //վϢ
	DrivingfaceCardMap mp_driving_face_card_list;//ʶϢ lemon
	WorkTypePermissionMap mp_worktype_permission_list;// lemon 2017/07/31
	RulesMap m_rules_list; // ڹб
	MapInfoMap mp_map_list; // еͼ
	LandmarkInfoMap mp_landmark_list; // еͼر
	MapDirectionInfoMap mp_map_direction_list; //ͼϵXļн
	DeptMap mp_dept_list; // в
	BanShiftMap mp_banshift_list; // Ϣ
	OccLevelMap mp_occlevel_list; // ְ񼶱

	AlarmTypeMap mp_alarm_type_list; // 澯б
	SectionMap mp_section_list; // ·б
	ChamberMap mp_chamber_list; // б
	LightMap   mp_light_list; // ͨб
	LightGroupMap mp_light_group_list; // ͨƵб

	unsigned long long m_Start_time;  // ʱ
	CardMap mp_card_list_all; // п
	CardMap mp_card_list_down_vehicle; // ³
	CardMap mp_card_list_down_person;  // Ա
	CardMap mp_card_list_up_person; // Ա
	CardMap mp_card_list_down_adhoc;   //
	PatrolTaskCheckMap mp_card_task_list; // Ѳ
	LeaderArrangeMap mp_leaderarrange_list; // 쵼
	VehicleTypeAttRuleMap mp_att_area_list; // бͬͣܲͬ
	MeetingInfoMap mp_meetinginfo_list; // ᳵسϢ

	AreaMap mp_workingface_area_list;		//
	CoalMiningRegularCycleMap m_coalmining_regularcycle_list;//úѭʼмֵ
	CoalWorkfaceVehicleMap m_coalWorkfaceVehicleMap; // ú복ID󶨱
	CoalMiningAreaMap m_coalmining_area_list;//۲úѭʵĲ

	CoalDrvingfaceCardMap mp_coaldringface_card_list;  // ú/б
	CardVehicleMap  m_card_vehicle;  // ӦID
	CardWorkfaceMap m_card_workface; // Ӧ

	VehicleDriverPosMap m_vehicleDriverPosMap;//˾λõƽλ//
	DeptVehicleDriverMap m_deptVehicleDriverMap;//복˾Ӧ//
	WorkfaceDriverAlarmMap m_WorkfaceDriverAlarmMap;//泵뱨Ӧ

	std::shared_ptr<ReaderPathMap> mp_reader_path_list_tof;	//ǰͼзվĸǷΧ
	std::shared_ptr<TDOAReaderPathMap> mp_reader_path_list_tdoa; 
	std::shared_ptr<CardMap> mp_card_list_over_time_person;	// ʱԱ	
	std::shared_ptr<CardMap> mp_card_list_forbidden_person; // Ա
	std::shared_ptr<CardMap> mp_card_list_help; // Ա
	std::shared_ptr<CardMap> mp_card_list_area_over_time_person; // ʱԱ
	std::shared_ptr<CardMap> mp_card_list_forbidden_vehicle; // 
	std::shared_ptr<CardMap> mp_card_list_over_time_vehicle; // ʱ
	std::shared_ptr<CardMap> mp_card_list_over_speed_vehicle; // ٳ
	std::shared_ptr<CardMap> mp_card_list_area_over_time_vehicle; // ʱ
	std::shared_ptr<CardMap> mp_card_list_over_count_person; // ԱԱ
	std::shared_ptr<CardMap> mp_card_list_over_count_vehicle; //Ա

	std::shared_ptr<AreaMap> mp_area_over_count_person; // ԱԱ
	std::shared_ptr<AreaMap> mp_area_over_time_person; // Աʱ
	std::shared_ptr<AreaMap> mp_area_forbidden_person; // 
	std::shared_ptr<AreaMap> mp_area_over_count_vehicle; // Ա
	std::shared_ptr<AreaMap> mp_area_over_time_vehicle; // ʱ
	std::shared_ptr<AreaMap> mp_area_forbidden_vehicle; // г

	std::shared_ptr<CardMap> mp_card_warning_point_alarm;//lemon
	std::shared_ptr<CardMap> mp_card_geofault_alarm;//lemon
	std::shared_ptr<CardMap> mp_card_list_motionless;
	std::shared_ptr<CardMap> mp_card_drivingface_eara_alarm;//lemon 20017/07/31 Ա澯
	std::shared_ptr<EventMap> mp_event_list; // ¼б
	std::shared_ptr<LightCallMap> mp_light_call_list; // ƺ̵б
	std::shared_ptr<CalDataMap> mp_ins_cal_data_list;
	std::shared_ptr<HandUpVehicleMap> mp_card_hand_up_list;//wangsiping 2017/10/11 ֶ϶ĳcard list
	std::shared_ptr<MovingReaderMap> mp_moving_reader_list;		//add by zhuyf 2017/10/18 ˿ϳʵ
	std::vector<DrivinfaceReaderTopology> vt_drivingface_reader_topology;	//žĴСվ˹ϵ

	unordered_map<unsigned long long, unsigned short> umpRootSyncNum;  // ÿrootͬ
	std::shared_ptr<Area_Map> mp_area_list_;
	CallInfoUserMap mp_user_call_info; // ûϢ

	_SLS sls_setting; // ϵͳ
	_DBS m_db_setting; // ݿ
	_DBS m_db_setting_bk; // ݿ
	string m_ws_url; // weburl
	string m_ws_url_ex; // url
	CString m_tcp_host; // շվݵip

	double m_reader_interval_time;
	INT64 m_event_list[MINE_EVENT_COUNT];
	int cur_shift_id;
	time_t cur_shift_start_time;

	// ɼ
	bool m_bYAserverBoot;
	// 㴦
	bool m_bZero;
public:
	void init_ui(); // ʼ
	void init_param(); // ʼв
	void init_queuestring(); // ʼݿ⻺
	void load_param_from_ini(); // ļв
	void database_connect(); // ݿ
	void stop_and_exit(); // ֹͣ˳
	void set_run_state(); // ޸Ľ水ť״̬

	// ݿгʼ 
	void init_base_data(); // 
	int init_setting(); // ϵͳ
	int init_alarm_type(); // 
	int init_shift(); // Ϣ
	int init_dept(); // б
	int init_level(); // 
	int init_card(string card_id = "");
	int init_special_card(string name = "");
	int init_staffer(string staff_id = "", bool is_card = false); // Ա
	int init_vehicle(string vehicle_id = "", bool is_card = false); // 
	int init_adhoc(string adhoc_id = "",bool is_card = false); // 
	int init_map(int map_id = 0); // ͼ
	int init_landmark(void); //·Ϣ
	int init_map_direction(void);//ͼϵXϵļн
	int init_area(int area_id = 0); // 
	int init_special_area_entry(void); // 
	int init_drivingface_card(void);//lemon init drivingface_card..
	int init_sensor();
	int init_coalface_driver_warningparam();
	int init_drivingface_permission_card(void);//lemon 2017/07/31
	int init_drivingface_ref_points();	//zhuyf 2018/12/14
	int init_reader(int reader_id = 0); // վ
	int init_ctrl_reader(int reader_id = 0); // Ʒվ
	int init_antenna(int reader_id = 0); // 
	int init_dev_adhoc(int reader_id = 0); // 
	int init_antenna_sync(); // ʼվ룬װʱͬ
	int init_all_readers_coverage(int reader_id = 0);			//ݿȡͼǷΧ,ʼзվĵͼ
	int init_tof_all_readers_coverage(int reader_id = 0);			//ݿȡͼǷΧ,ʼзվĵͼ
	int init_tdoa_all_readers_coverage(int reader_id = 0);			//ݿȡͼǷΧ,ʼзվĵͼ
	int init_traffic_lights(int light_id = 0);		//ʼ̵
	int init_chamber(int chamber_id = 0);				//ʼ
	int init_section(int section_id = 0);				//ʼ·
	int init_light_group(int group_id = 0);				//ʼ̵
	int init_light_state(CONNID dwConnID,std::string strIp);
	int init_rules(int rule_id = 0); // ʼ 2017/08/01
	int init_leader_arrange(); // 쵼Ű
	int init_smart_pointer_var();
	int init_reader_boundary_area(int reader_id = 0);			// ݿжȡ߽Ϣʼվı߽
	int init_moving_reader(int reader_id = 0);					// ݿжȡƶվϢ
	void clear_leader_arrange(); // б
	void clear_att_area();
	int init_handup_vehicle();//ʼֶlist,webֶ϶ͼ깦
	int is_in_handup_area(double real_x, double real_y, double list_x, double list_y);//λǷֶ϶긽
	void erase_handup_vehicle(std::string card_id);//hand_upݿеĶӦ¼
	int refresh_handup_list(string cardid);//ˢhand_up list
	void deal_card_msg_handup( std::shared_ptr<Card> card );//ֶϳҵ
	void deal_card_dept_changed(std::shared_ptr<Card> card, int dept_id); // 

	int init_data_coalminingface_RegularCycle();//ʼ۲мѭʵĲ
	int init_data_coalmining_RegularCycle();//ʼúмֵ
	int init_data_pre_coalmining_RegularCycle();//ʼúйѭʼǰ
	int init_restart_halfcoalmining_regularcycle();//ʼ뵶δɵѭ
	int store_data_coalmining_Regular_cycle(std::shared_ptr<CoalminingRegularCycleDetail> ReguilarCycle );//洢úÿʼ
	int store_halfknife_coalmining_Regular_cycle(std::shared_ptr<CoalminingRegularCycleDetail> reguilarCycle );//洢úǰ뵶ʼ
	int Update_data_coalmining_Regular_cycle(std::shared_ptr<CoalminingRegularCycleDetail> reguilarCycle );//洢úÿ
	int update_halfknife_coalmining_Regular_cycle(std::shared_ptr<CoalminingRegularCycleDetail> reguilarCycle ); //ɰ뵶µֵ
	int get_data_coalmining_scheduletimes(int workface_id,double& scheduletimes);//ȡ۲ļƻ
	void find_regularcyclerate_startpoint(CoalFaceStartPos &pos, std::shared_ptr<Card> card,std::shared_ptr<CoalMiningArea> area, int tagNum, std::shared_ptr<CoalMiningRegularCycle> coal); // Ҳúλ
	//lemon monkey car 2017/09/27
	//void init_monkeycar_info();
	void init_monkeycar_base_info();
	void init_coordinate_string2vec(string  str,vector<point_2>&tmp);
	//int init_patrol_info(int task_id = 0); // ѲѲ·/
	int init_patrol_info(std::string card_id);
	int delete_patrol_info(std::string card_id);
	int get_help_card_nums();
	int init_att_area(); // 뿼Ϣ

	// ʷ
	void load_his_data();
	void load_his_area(); // 
	void load_his_event_data(); // վ״̬
	void load_his_card_postion_vehicle(); // λ
	void load_his_card_postion_staff();
	void load_his_driving_face_card_postion(); // λ

	void load_his_driving_face_card_state(); // 濨״̬
	void init_drivingface_warning_point();
	void init_geological_fault();
	void load_his_card_state(); // ؿ״̬
	void load_drivingface_card_curshift_position();//ʷмؾĳʼ״̬ǰεĿʼֵ
	float get_drivingface_warning_point_dis(std::shared_ptr<Card> card);

	// 뱨
	void load_alarm_reader();

	MYSQL_RES* getMysqlRes(const char* sql);
	// ӿݽΪǰ˷͹
	void parse_edit_map(int map_id);
	void parse_edit_area(int area_id);
	void parse_edit_reader(int reader_id);
	void parse_edit_card(string card_id);
	void parse_edit_staffer(string staffer_id);
	void parse_edit_vehicle(string vehicle_id);
	void parse_edit_path(int path_id);
	void parse_set_limit_value();
	void parse_call_card();
	void parse_clear_card();
	void parse_deal_help();
	// ʼwebsocket
	void ws_init(); // ʼȫֱ
	void ws_open();  // 
	void ws_close(); // ر
	void ws_login(); // ¼
	void ws_logout(); // ˳

	void ws_init_ex();
	void ws_open_ex();
	void ws_login_ex();
	void ws_logout_ex();

	void clear_listener();  // ˳socket
	void clear_all_list();  // ˳лб
	// socket
	// ݰṹΪ ݳ +  + վ + ʶ * N + CRCУ
	void parse_data_server(const BYTE * pData, int nLen, CONNID dwConnId); // socketյݰճ
	void parse_package_data(BYTE* DataBuffer, int nLen, CONNID dwConnID); // վ͵ĵݰ
	// λ
	void parse_data_locate_reader(BYTE * DataBuffer, int& nCurPos, int nLen, CONNID dwConnID, int& reader_id); // վ
	void parse_data_ctrl_reader(BYTE * DataBuffer, int& nCurPos, int nLen, CONNID dwConnID, int& reader_id); // Ʒվ
	void parse_data_signal_lamp(BYTE * DataBuffer, int& nCurPos, int nLen, CONNID dwConnID);	//źŵ
	int parse_inav_msg(INAVLocateMsg* msgPtr); // ߵ
	void deal_inav_locate_msg(INAVLocateMsg* msgPtr, int card_num); // ߵλ
	INAV_STATUS calculate_inav_state(INAVLocateData* cardData); // ߵ
	void calculate_inav_locate_by_magic(std::shared_ptr<Card> card, INAVLocateData* cardData); // ݵشݼλ
	void write_inav_locate_magic_data(std::shared_ptr<Card> card, INAVLocateData* cardData); // 洢شݼ
	void log_card_inav_state(INAV_STATUS card_state, string card_id); // ߵд뵽־
	void parse_data_lights_state(BYTE* DataBuffer, int& nCurPos, int reader_id, unsigned short wChr); // ͨ
	//int parse_data_locate_card(BYTE* DataBuffer, int& nCurPos, int reader_id, unsigned short wChr);
	int parse_data_moving_reader(BYTE * DataBuffer, int& nCurPos, int nLen, CONNID dwConnID, int& reader_id);			// ƶվ 
	int parse_data_moving_reader_card(BYTE* DataBuffer, int& nCurPos, int reader_id);		// վϴƶվ
	unsigned long long  parse_data_locate_card(BYTE* DataBuffer, int& nCurPos, int reader_id, unsigned short wChr, unsigned long long ct_time = 0,int pos = 0);  // 
	int get_locate_msg_type(BYTE* DataBuffer); // ȡݶλʽtoftdoa
	std::shared_ptr<Card> parse_tof_locate_msg(TofLocateMsg* DataBuffer, int cardNum); // tof
	int parse_data_signal_lamp_req_status(BYTE * DataBuffer, int& nCurPos, CONNID dwConnID, uint32_t& id);	//źŵ״ָ̬
	void send_signal_lamp_status(const uint32_t& id);	//·˺̵Ƶ״̬

	void get_schedulestartuptime(int cardType, std::string strCard,double &scheduleStartupTime,std::string strDate); // ¿ֶ
	std::string get_json_vehicle_state();  // 쳵״̬JSON
	void open_machine(std::shared_ptr<Card> card);       // 
	void close_machine(std::shared_ptr<Card> card, bool bTimeOut=true);      // ػ
	int restart_update_unprocess_record(); // δ¹ػʱļ¼
	int bind_card_vehicle();      // 󶨳뿨
	int bind_card_workface();     // 󶨳빤
	void get_shakethrethold(std::shared_ptr<Card> card, int &threshold);   // ȡֵʱlinux
	int zero_update_unprocess_record(time_t tCurTime); // ʱػٿ
	int store_machine_state(std::shared_ptr<Card> card); // 洢ú/ػ״̬ʱεݿ

	void parse_data_locate_card_vehicle(BYTE* DataBuffer, int& nCurPos,  std::shared_ptr<Card> card, unsigned short wChr); // ݣtoftoda
	// Эվʷ
	void parse_data_locate_reader_his(BYTE * DataBuffer, int nLen, int& nCurPos, int& reader_id, int& nTick, CString& strtime, unsigned short wChr);
	void parse_data_locate_card_his(BYTE* DataBuffer, int& nCurPos, int reader_id, DWORD wTickCount, CString strTime, unsigned short wChr);
	void parse_data_locate_card_his_tdoa(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime);
	void parse_data_locate_card_his_tdoa_package(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime, CString strHistTime);
	void parse_data_locate_card_his_tof_card(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime, CString strHistTime);
	void parse_data_locate_card_his_tdoa_card(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime, CString strHistTime);
	void parse_data_locate_card_his_sync_time(BYTE* DataBuffer, int nLen, CString strTime,  CString strHistTime, WORD wChr);
	// 
	void parse_data_adhoc(BYTE* DataBuffer, int& nCurPos,  int reader_id);
	// վʱͬ
	void parse_data_reader_synctime(BYTE *DataBuffer, int nLen, int& nCurPos, WORD wChr);

	std::shared_ptr<_SOCK> get_socket_by_Id(CONNID dwConnID); // бͨconnidȡsocket
	void add_socket_to_list(CONNID dwConnID, DWORD reader_id, DEVICE_TYPE rt); // 
	int  add_socket_to_list(CONNID dwConnID, DWORD reader_id, DEVICE_TYPE rt,BOOL refresh); // ӵsocketӵб
	string get_ip_by_id(const CONNID& dwConnID);		//idipַ

	void remove_socket(CONNID dwConnID); // socketжϺ󣬴бɾ
	// վ
	BOOL SendData(CONNID dwConnID, WORD wCharacterWord, int wLength, BYTE* DataBuffer);
	// õĵӵб,ͬһƵ״̬Ḳǣʹһ״̬
	void add_light_to_call_list(LIGHTS_SELECT_TYPE lst, LIGHT_COLOR clr, LIGHT_CTRL_STATE ctrl, int tkid, LIGHT_SHAPE ls,int light_id = 0);  // Ƶָ뵽ָб
	void send_call_light(); // ͿƵָ
	void send_call_light(BYTE ctrl_cmd, int light_id, int ctrl_type, int ctrl_color,int light_shape); // 
	void send_call_light(int light_id,int color,std::string ip);
	void send_call_light(const int& light_id,const bool& postive,const int& color,const std::string& ip);
	void send_call_light(const int& light_id,const uint8_t& p_color,const uint8_t& n_color,const std::string& ip,bool b);
	LIGHT_SHAPE get_light_sharp(const op::LIGHT_COLOUR& color);

	// ȡjson
	string get_json_login(); // websocket¼ӿ
	string get_json_logout(); // websocket˳ӿ
	bool   need_display_verification(std::shared_ptr<Card> card); //ǷҪ false Ҫ true ִ
	string get_json_down_and_up(std::shared_ptr<Card> card); // 뾮ӿ,뾮ʱ
	string get_json_special_area_process(std::shared_ptr<Card> card); // ӿڣʶźŶʧҵжϳӦʱ
	string get_json_all_special_area_data(); // ĳǰ˵¼ʱȫ
	string get_json_drivingface_card_position(std::shared_ptr<Card> card); // ״̬ӿڣ͸web
	int insert_data(int index, int key, StatisticDataStr** header); // ǰʵʱʱʹ
	void delete_memory(StatisticDataStr *header); // ͷžֲ
	//int get_json_statistic_vehicle_data(Json::Value& vehicle_data);

	Json::Value get_json_statistic_vehicle_data(Json::Value& vehicle_data);
	Json::Value get_json_statistic_staff_data(Json::Value& staff_data);
	Json::Value get_json_statistic_data(StatisticDataStr* header); // ÿ뷢ͳݣпλϢԱ  == еݳjson
	int get_json_node_position(std::shared_ptr<Card> card,Json::Value& detailNode);
	string get_json_card_statistic();//ʵʱλϢ handle get_json_statistic_vehicle_data  get_json_statistic_staff_data
	string get_json_all_data(); // ǰû¼ʱ
	string get_json_device_state(); // վ״̬Ϣ
	string get_json_help();			//json
	string get_json_event(bool bAll = false);
	string get_json_all_traffic_lights();//lemon 2018/05/15
	void get_json_all_traffic_lights(std::shared_ptr<op::TrafficLightGroup>);//lemon 2018/05/15

	string get_json_call_list(); // б not handle
	string get_json_new_device_state(); // վ״̬Ϣ
	string get_json_count_area();	//ͳ not handle
	string get_json_leader_arrange(); // 쵼

	Json::Value get_section_json_alarm(); // ·θ澯
	Json::Value get_light_json_alarm(); // ̵Ƹ澯
	Json::Value get_red_light_json_alarm(); // Ƹ澯

	void send_json_data(string cmd, string data, bool is_login = false); // web˷json
	// ҵ
	void deal_readers();  // ͳƷվ״̬Ϣ 
	void deal_readers_event(EVENT_TYPE et,bool falg,const std::shared_ptr<Reader> &r);
	void deal_lamp_light_event(EVENT_TYPE et,bool flag,const std::shared_ptr<op::TrafficLight>& ptl);
	void deal_areas(); // ͳ״̬Ϣ糬Ա
	void set_card_pos_state(std::shared_ptr<Card> card); //ñʶ״̬
	void deal_card_msg(std::shared_ptr<Card> card, bool is_hist = false); // ݱʶλãҵ
	int store_data_run_red_light(std::shared_ptr<Card> card,std::shared_ptr<RunRedLight> runredlight);
	void deal_run_red_light_alarm(std::shared_ptr<RunRedLight> runredlight, bool is_red_light);
	void deal_run_red_light_alarm(std::shared_ptr<Card> card,std::shared_ptr<RunRedLight> runredlight);
	void Calc_CoalMining_RegularCycleRate(std::shared_ptr<Card> card);//úѭ
	int store_data_coalmining_Pos(int workface_id, std::string dis_record);//60sϱúλ
	void cal_card_position_by_msg(std::shared_ptr<Card> card); // ݽյĵײݼʶλ
	void deal_hist_card_postion(); // ݼʷʶλãñʶϢ
	void deal_his_card_list(std::shared_ptr<Card> card); // üʷʶ״̬

	void card_enter_mine(std::shared_ptr<Card> card); // 뾮жϣݾϾ״̬ж뾮
	void card_enter_mine(std::shared_ptr<Card> card, POS_DEVICE_TYPE pdt); // 뾮pdt뾮
	void card_down_mine(std::shared_ptr<Card> card); // 뾮ҵ1֪ͨǰˣ2⣬3
	void card_up_mine(std::shared_ptr<Card> card); // ʶĴ1֪ͨǰˣ2⣬3ظ澯4б״̬
	void card_enter_map(std::shared_ptr<Card> card); // ʶλлͼݷվڵͼж
	void card_enter_area(std::shared_ptr<Card> card); // ʶл
	//lemon monkey car
	void handle_reverse_alarm(std::shared_ptr<Card> card,int16_t antid,uint32_t ct,double d);
	//lemon 2017/11/20
	void card_deal_other_business(std::shared_ptr<Card> card);
	bool determine_Save_Point_Or_Not(std::shared_ptr<Card> card);
	void deal_alarm_card_motionless(std::shared_ptr<NAMESPACE_POINT::card_interface> ci,bool flag);
	void iksdk_db(const std::shared_ptr<Card> card);

	void card_enter_special_area(std::shared_ptr<Card> card, int area_id); // ʶ
	void card_leave_area(std::shared_ptr<Card> card, std::shared_ptr<Area> area); // ʶ뿪ȫ뿪ʱ䡢ظ澯
	void deal_card_state(std::shared_ptr<Card> card); // ʶ״̬ҪΪ͵ͺ״̬
	void deal_card_drivingface_permission(std::shared_ptr<Card> card); // ݹжϣ澯ҵ
	void deal_card_drivingface_permission(std::shared_ptr<Card> card,int id); // ݾжϣ澯ҵ
	void deal_alarm_card(std::shared_ptr<Card> card, std::shared_ptr<CardMap> dest_card_list, bool is_alarm, ALARM_FLAG tag); // ʶϢʱٵ
	void deal_drivingface_alarm(std::shared_ptr<Card> card, bool is_alarm, ALARM_FLAG tag);// 澯¼洢ݿ
	void deal_drivingface_alarm_all(std::shared_ptr<Card> card,std::shared_ptr<DrivingfaceCard> drivingface_card); // 澯ҪΪΣյ澯
	void deal_alarm_area(std::shared_ptr<Area> area, std::shared_ptr<AreaMap> dest_area_list, bool is_alarm, ALARM_FLAG tag,int tyep); // 澯ҵ߼
	void deal_warning_point_alarm(uint64_t key,const std::shared_ptr<Card>&card);
	void deal_card_lost_state(); // ʶźŶʧҵж
	int get_special_area_id(shared_ptr<Card> card); // ʧźźͨλãжϳä
	int  deal_traffic_lights(std::shared_ptr<Card> card); // ݿλáƽͨ
	void deal_alarm_vehicle(const std::string & cid,std::shared_ptr<Card> c1=nullptr);
	int get_drivingface_area_id(const std::string& card_id);	//idȥϢ


	int  deal_over_speed(std::shared_ptr<Card> card);		//
	int  deal_area_over_speed(std::shared_ptr<Card> card);		//
	int  deal_relationship_between_person_and_vehicle(std::shared_ptr<MovingReader> pReader); // ϳҵж
	int  deal_relationship_between_person_and_vehicle(std::shared_ptr<Card> card); // ϳҵж
	int  card_enter_chamber(std::shared_ptr<Card> card,std::shared_ptr<Section> section); // ܳңδ
	int  select_pos_output(std::shared_ptr<Card> card); // ͨʻѡƫƺλ꣬δ
	void cal_distance_of_card(); // ѭȽϳ֮ľ룬³ᳵ״̬
	void reset_vehicle_meeting_state(); // óᳵ״̬
	void reset_map_card(); // ͼлıʶб, δʹ
	bool is_in_rectangle(_point p, double dblleft, double dbltop, double dblright, double dblbottom); // жϵǷھοռ
	bool is_in_circle(_point p1, _point p2, double r, double scale); // жϵǷԲ
	// save to database
	void execute_sql(const char* sql); // ִsql䣬浽ݿ

	void deal_card_drivingface_real(std::shared_ptr<Card> card,std::shared_ptr<DrivingfaceCard> drivingface_card); // ʵʱ
	void calculate_card_postion_by_tof(std::shared_ptr<Card> card); // 濨λ
	void process_driving_face_start_service(std::shared_ptr<Card> card); // ɾ
	void send_drivingface_card_position_json(bool approve = false); // ǰ˷;ȼ״̬Ϣ
	void write_drivingface_shift_start_data(std::shared_ptr<Card> card); // µľػ¼
	void driving_face_shift_start(); // жµľνȼ¼
	void process_driving_face_end_service(std::shared_ptr<Card> card); // ͣȫػ¼
	void store_driving_face_data(std::shared_ptr<Card> card);  // µľν
	void update_driving_face_data(std::shared_ptr<Card> card);// ¾ν
	void write_his_drivingface_real(std::shared_ptr<Card> card); // ʵʱλϢֻ
	void save_card_postion(std::shared_ptr<Card> card); // 濨ʷλ
	void save_raw_data_card_tof(std::shared_ptr<Card> card); // tofʵʱϢϢ
	void save_card_postion_ex(std::shared_ptr<Card> card); // ¼
	bool IsInLine(_point p1, _point p2, _point p3); // жǷͬһֱ

	void store_data_card(std::shared_ptr<Card> card, int tag); // tag뿨صݣҪΪλáڡ¼
	void store_data_event(std::shared_ptr<YaEvent> ev); // 澯¼¼
	void save_patrol_data(std::shared_ptr<PatrolTask> pTask, std::shared_ptr<PatrolPoint> pPoint); // Ѳ״̬¼

	int  store_data_light(std::shared_ptr<Light> light,int tag);  // 洢ͨ״̬Ϣ
	int  store_data_traffic_red_light(std::shared_ptr<Light> light,std::shared_ptr<Card> card);	//洢
	int  store_data_section(std::shared_ptr<Section> section,time_t cur_time,int tag); // 洢·״̬

	// 
	void package_data(); // λjson͸ǰ
	// ͨ÷
	int API_TimeToString(string &strDateStr,const time_t &timeData); // ʱתַ
	int API_StringToTime(const string &strDateStr,time_t &timeData); // ַתʱ
	//void formatByteArray(CString &strBuf, BYTE * buf, int nLen);
	time_t formatByteArray(std::string &strBuf, BYTE * buf, int nLen); // յֽ飬ʽΪ16ַ
	time_t formatByteArray_s(std::string &strBuf, std::string ip,BYTE * buf, int nLen); // յֽ飬ʽΪ16ַ
	void show_log( LPCTSTR szlog, BOOL bSave = true); // ʾϢ
	void AddItem(CString strvalue, int readerid, BOOL is_closed, DEVICE_TYPE rt); // ʾӵķվб
	void AddItem(std::shared_ptr<_SOCK> &s);
	// Ӧwebӿ
	void parse_json_data_set_limit_value(const char* sz);  // Ӧweb˷͵ϵͳָ
	int parse_json_data_hand_up(string card_id); // Ӧweb˷͵ƶֹĳͼָ

	void parse_json_data_call_card_cancel(sio::message::ptr const& data); // Ӧweb˷͵ȡָ
	void parse_json_data_call_card(sio::message::ptr const& data); // Ӧweb˷͵ĺָ
	void parse_json_data_clear_card(sio::message::ptr const& data); // Ӧweb˷͵äָ
	void parse_json_data_deal_help(sio::message::ptr const& data); // Ӧweb˷͵Ĵָ
	int  parse_json_data_set_light_color(sio::message::ptr const& data); // Ӧweb˷͵Ŀƽָͨ
	int  parse_json_data_request_counts_info(sio::message::ptr const& data); // Ӧweb˷͵ͳƼָ
	int  parse_json_data_reader_pos_change(sio::message::ptr const& data); // Ӧweb˷͵ķվλøıָ
	string  parse_json_data_person_on_car(sio::message::ptr const& data); // Ӧweb˷͵ĸûϳ״ָ̬

	void deal_call_edit_map(int id, EDIT_TYPE_ID edit_type_id); // ǰ˱༭ͼ֪ͨɼɼ
	void deal_call_edit_area(int id, EDIT_TYPE_ID edit_type_id); // ǰ˱༭֪ͨɼɼ
	void deal_call_edit_reader(int id, EDIT_TYPE_ID edit_type_id); // ǰ˱༭վ֪ͨɼɼ
	void deal_call_edit_card(string id, EDIT_TYPE_ID edit_type_id); // ǰ˱༭ʶ֪ͨɼɼ
	void deal_call_edit_staff(string id, EDIT_TYPE_ID edit_type_id); // ǰ˱༭Ա֪ͨɼɼ
	void deal_call_edit_vehicle(string id, EDIT_TYPE_ID edit_type_id); // ǰ˱༭֪ͨɼɼ
	void deal_call_edit_adhoc(string id, EDIT_TYPE_ID edit_type_id); // ǰ˱༭֪ͨɼɼ
	int  deal_call_edit_section(int id,EDIT_TYPE_ID edit_type_id);		//web˱༭·Ϣ
	int  deal_call_edit_light(int id,EDIT_TYPE_ID edit_type_id);		//web˱༭Ϣ
	int  deal_call_edit_light_group(int id,EDIT_TYPE_ID edit_type_id);	//web˱༭̵Ϣ
	int  deal_call_edit_chamber(int id,EDIT_TYPE_ID edit_type_id);		//web˱༭Ϣ
	void deal_call_edit_rules(int id,EDIT_TYPE_ID edit_type_id);//lemon 2017/08/01
	int  get_ins_cal_list();			//ùߵУ׼б
	std::string  get_json_person_on_car();		//ϳjsonmap<string,OnVehicleData> real_on_card_data;
	std::string  get_json_person_on_car(map<string,OnVehicleData>& real_on_card_data);		//ϳjson;
	std::string  get_json_all_person_on_car(std::string val);	//Ƿڳϵ״̬б
	Json::Value  get_json_all_person_on_car();	//Ƿڳϵ״̬б

	void deal_call_edit_patrol_task(string id, EDIT_TYPE_ID edit_type_id); // ǰ˱༭Ѳʱ֪ͨɼ
	void remove_card(string card_id); // бɾʶ¼Ҫǰ˱༭Ϣִɾ
	void clear_card_from_list(std::shared_ptr<Card> card); // ӻбɾʶʱʹ

	void add_event(std::shared_ptr<YaEvent> ev); // ¼ӵȫֻбһǲµĸ澯Ǹ¸澯Ϣ
	void remove_event(std::shared_ptr<YaEvent> ev); // ӱ¼бɾʱʹ

	void check_patrol(); // Ѳ״̬жϣϵͳʱѲ״̬
	void send_call_info(); // վ·վյ󣬰ָ͸ʶ
	void send_call_his_data(); // վ·ʷվյ󣬷ͻʷݣʷ4M
	void send_sync_reader(); // վ·УʱУ׼վʱ䣬ȷ 
	int send_heart_package(); // Ʒվ֮䷢ݰƷվӦǷ
	void clear_call_info(); // ݺ״̬ʱбгɹĿﵽʱĿ
	void clear_call_card_by_user(std::string user_name); // ûб
	int get_card_id_len(int card_type); // ͨͻȡųȣֻһֽ
	int modify_card_speed(int val); // Уʶٶ
	int send_ins_data();			//͹ߵУ׼
	int send_change_reader_to_card();	//վ·СվлΪģʽ
	void set_reader_simulate_status(const int& reader_id,bool status);
	void check_reader_simulate_status();		//վģ⿨״̬5ӣп
	void send_light_auto_control_param(const uint32_t& id,const uint16_t& value,const std::string& ip);	//̵·ԶƵļʱ
	void deal_light_auto_control_param(const uint32_t& id,CONNID dwConnID);								//ú̵ԶƵļʱ

	void deal_simulate_card(std::shared_ptr<Card> pCard);		//ģ⿨
	bool need_drivingface_algo(std::shared_ptr<Card> pCard);	//˿ǷҪþ㷨
	void deal_drivingface_regular_cycle(std::shared_ptr<Card> pCard,const op::point& p);	//ѭ
	void deal_drivingface_regular_cycle();	//ʱѭ
	void deal_drivingface_services(std::shared_ptr<Card> pCard);		//ҵ1.ѭʣ2.ÿ쵱ÿһʱ̵ľ
	void deal_drivingface_real_distance(std::shared_ptr<Card> pCard);	//ÿһʱ̵ľ룻
	void deal_drivingface_real_distance();		//ʱ룻
	void init_drivingface_recently_info(std::shared_ptr<Card> pCard);	//ʼλú;Ϣ
	void save_drivingface_regular_cycle_data(std::shared_ptr<Card> pCard,std::shared_ptr<DrivingfaceCard> pDrivingfaceCard,const op::point& p);	//㲢ѭ
	op::point get_drivingface_base_point(std::shared_ptr<Card> pCard);	//þĻ׼λϢ
	void smooth_row_spacing(double& value,const double& sv);								//ƽžϢ
	int get_forbidden_area_id(const _point& p);		//id
	int auto_call_person(std::shared_ptr<CardMap>& person_list);			//Ա
	int cancel_call(const std::string& card_id);							//ȡָĺ

	bool is_has_chamber(int section_id);	//·ڴڿõ
	bool isInMainTunel(std::shared_ptr<Card> pCard);		//˿Ƿ
	int getTunelProperty(std::shared_ptr<Card> pCard);		//ÿֵ
	void AnalysisAlgoFailedData(int interval = 60000 /*std::shared_ptr<Card> pCard*/);
	int GetLandmarkID(std::shared_ptr<Card> card); // ȡ뵱ǰλĵرϢ
	double GetDistance(_point p1, _point p2); // ȡľ룬λرľ
	time_t GetCurShiftStartTime(int& shift_id); // ȡǰοʼʱ
	time_t GetCurShiftEndTime();  // ȡǰνʱ
	time_t GetLastShiftStartTime(int& shift_id); // ȡһοڰοʼʱ
	int GetCurShiftId(struct tm* current_time, int shift_type = 1); // ȡǰα
	void GetLandmarkInfo(std::shared_ptr<Card> card); // ͨʶĵرϢʶλ

	DIRECTION_TYPE GetDirectionType(_point card_point, _point landmark_point, int map_id); // ȡڵرĸ
	POS_DEVICE_TYPE GetPosDownAndUp(int vehicle_type_id, int area_id); // ݳͺţͨù򣬻ȡǰǷΪ
	int get_parent_anchor_id(const int& id);	//anchor_idipĴվ
	int get_parent_anchor_id(const std::string& id);
	uint64_t get_drivingface_schedule_value(const uint64_t& id,const uint8_t& type);	//ݾ۲idͲѯָľƻ

	void reader_power_battery_alarm(const uint64_t& id,const uint8_t& status);	//عҪ͸澯
	void deal_lamp_light_alarm();

	void deal_vehicle_driver_alarm(std::shared_ptr<Card> card);//鹤˾복澯

	int get_vehicle_driverlist(int dept_id, int worktype_id, std::vector<int>& driverList);//ȡúӦ˾б
	void Init_data_vehicle_meanpos(std::shared_ptr<Card> card);//ʼúھ˾ĶӦϵ,ʼƽ
	void remove_vehicle_meanpos(std::shared_ptr<Card> card);//ȥĳصĹ˾복澯Ϣ
	void remove_person_meanpos(std::shared_ptr<Card> card);//ȥĳصĹ˾복澯Ϣ
	void add_person_meanpos(std::shared_ptr<Card> card);//ĳصĹ˾복澯Ϣ
	
	void deal_vehicle_driver_changed(std::shared_ptr<Card> card,bool isCalc=false);//泵˾澯仯Ŀػ͵˼澯ʱ䣩
	void start_end_vehicle_driver_alarm(std::shared_ptr<Card> card,bool isStart,double limitdis=0.0,double realdis=0.0);//ʼ˾복澯
	bool calc_vehicle_driver_distance( double mean_vx,double mean_vy,double& distance, std::shared_ptr<VehicleDriverPos> driverPos);//˾복ľ
	void reset_vehicle_driver_pos(std::shared_ptr<VehicleDriverPos> Pos);//ĳƽ
public:
	int init_workingface_area(int area_id = 0);
public:
	//Ժ
	void ReadTdoaDistFile(); // distļжȡϢ
	int  ReadTofDistFile();			// TOFļжȡݣ
	int  TestGenerateAllDataJson(); // Ե¼ݽӿ
	int  TestPersonOnCardJson();	// ϳӿ
	void TestLandmarkRequirement(); // ԵرϢ
	void TestCallCard(); // Ժнӿڣվ
	void TestParseCallCard(); // Ժнӿڣǰָ
	void TestFitData(); // 
	void TestMultSql(); // д
	void TestCardPosition(); // Կʻ
	void TestClock();			//Ը߾ʱ
	string get_json_call_test(); // װвjson
	void package_data_test(); // װλjson
public:
	std::unique_ptr<sio::client> _io;
	CListBox m_list_log;
	CReportCtrl m_listctrl_reader;

	// websocket
	void OnPushMessage(); // ǰ˷
	// ǰ˷͵jsonϢ
	void OnCallMessage(string const& name, sio::message::ptr const& data, bool isAck,sio::message::list &ack_resp); 
	// Ӧ¼
	void OnLogin(string const& name, sio::message::ptr const& data, bool isAck, sio::message::list &ack_resp);
	// websocket ӳɹ¼
	void OnConnected();
	// websocket ӹرմ¼
	void OnClosed(sio::client::close_reason const& reason);
	// websocket ʧܴʱ
	void OnFailed();

	// Web
	std::unique_ptr<sio::client> _io_ex;
	void OnLoginEx(string const& name, sio::message::ptr const& data, bool isAck, sio::message::list &ack_resp);
	void OnConnectedEx();
	void OnClosedEx(sio::client::close_reason const& reason);
	void OnFailedEx();
	std::string time_t2string_date(const time_t& t);//time_tȡ
	// ָsocketӷУ׼ʱ add by zhuyf
	int send_sync_reader(CONNID dwConnID);
protected:
	
	afx_msg LRESULT OnRemoveSocket(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMsgRefreshIpList(WPARAM wParam, LPARAM lParam);
public:
	UINT m_reader_id_hist;
	afx_msg void OnEnUpdateEditReaderid();
	afx_msg void OnAbout();
	afx_msg void OnBnTest();
public:
	/*
	*@brief
	ʱж
	*param [in] enter_time ʱ
	*param [in] cur_time ǰʱ
	*param [in] area_id ǰid
	*param [in] tag ʶ
	*param [in] staff_id ԱID
	*param [out] current_leave_time ʱ
	*/
	void GetCurrentLeaveAreaTime(const char* enter_time,const char* cur_time,int area_id,string &current_leave_time,int staff_id,int tag = HIS_AREA_LOCATION_LEAVE);
	//ʱ
	void store_worktime_detail(std::shared_ptr<Card> card,int tag,const char* cur_time);
	bool GetStartWorkTime(int id, char* start_work_time);
	//ʱδĿ
	int Init_worktime_detail();
};

typedef struct {
	CYAServerDlg* handle;
	int len;
	CONNID dwConnID;
	BYTE buf[LENGTH_MSG_4K];
}ParseData;

typedef struct 
{
	CYAServerDlg* handle;
	bool useTime;
	char* path;
	char* strLog;
}LogInfo;