#pragma 
#ifndef YASERVER_CELL_STRUCT_H_
#define YASERVER_CELL_STRUCT_H_

#define CELL_WIDTH 0.3	//ӿȣλΪ
#define SEND_CELL_INTERVAL 500
#define BRANCH_RANGE 6	//֧ȷϷΧλΪ
#define LAST_V_POWER 0.7
#define THIS_V_POWER 0.3
#define MAX_CHANGE_DIR_COUNTS 5
#define MAX_CELL_FORWARD_JUMP 20		//15
#define MAX_IDLE_CELL_THRE 2			//ٵԱֵ
#define FIT_RELIABILITY 0.7				//Ȩ
#define MAX_FIT_DATA_COUNTS 5			//ͳ
#define MAX_IDLING_HISTORY_DATA_COUNTS 15			//ʷݶ, ڵж
#define MAX_DIRECTION_COUNTS 5			//ͳ

struct point{
	double x;
	double y;

	point(){
		x = y = 0;
	}

	point& operator=(point& p){
		x = p.x;
		y = p.y;

		return *this;
	}
};

struct ReaderInfo{
	int reader_id;
	double x;
	double y;
	double z;

	ReaderInfo(){
		reader_id = 0;
		x = y = z =0;
	}

	ReaderInfo& operator=(ReaderInfo& v){
		reader_id = v.reader_id;
		x = v.x;
		y = v.y;
		z = v.z;

		return *this;
	}

	bool operator<(ReaderInfo& v) const{
		if (abs(x-v.x) < 1E-2)
		{
			if (y < v.y)
			{
				return true;
			}else{
				return false;
			}
		}else{
			if (x < v.x)
			{
				return true;
			}else{
				return false;
			}
		}
	}
};

//Ϣ20170705
class Cell{
public:
	Cell(){
		strSubjectReader = "";
		strOriginReaderName = "";
		id = 0;
		nStep = 0;
		minReaderId = maxReaderId = 0;
		dataSource = 0;
		card_stamp_time = 0;
		isHasBranch = false;
		isFit = isOverThre = false;
		isChangePath = false;
		top.x = top.y = bottom.x = bottom.y = left.x = left.y = right.x = right.y = 0;
		originId = 0;

		::GetLocalTime(&deal_time);	
		::GetLocalTime(&interval_time);
	}
	~Cell(){}

public:
	int id;				//id
	int minReaderId;	//˸ķվ·еСվ
	int maxReaderId;	//˸ķվ·еվ
    int originMinReaderId;
    int originMaxReaderId; 
	int nStep;			//һθӵĲ
	//Դ0Ϊδ֪1Ϊλ㷨,2Ϊʱ, 3 㷨ֵ, ܱ̿滻Ϊľֵ
	// 10Ժ㷨
	// 10 ޳Ұֵ, 
	// 11 λ position ʧ, һʧ, 
	// 14 ͨ id ж˶Ƿͬ, ͬ, жϻ˴ǷС10, ٲֵ
	// 15 ͨ id ж˶Ƿͬ, ͬ
	int dataSource;	    
	int originId;		//ԭʼλתԭʼid

	int card_stamp_time;	//ct

	std::string strSubjectReader;		//վ
	std::string strOriginReaderName;	//ԭʼվͨԭʼӺ+ԣΨһȷӵĵ

	point top,bottom,left,right;	//ӵ4λ
	
	bool isHasBranch;				//˸ӸǷз֧
	bool isFit;						//˸ǷϳĽ
	bool isOverThre;				//ǷԽ磬ߴ
	bool isChangePath;				//Ƿлվ

	SYSTEMTIME deal_time;			//ӵĴʱ
	SYSTEMTIME interval_time;		//ӵ0,500msʱ

    int realId;

public:
	double getX(){
		return (this->top.x + this->bottom.x)/2;
	}
	double getY(){
		return (this->top.y + this->bottom.y)/2;
	}

public:
	Cell& operator=(Cell&c){
		id = c.id;
		nStep = c.nStep;
		minReaderId = c.minReaderId;
		maxReaderId = c.maxReaderId;
        originMinReaderId = c.originMinReaderId;
        originMaxReaderId = c.originMaxReaderId;
		strSubjectReader = c.strSubjectReader;
		dataSource = c.dataSource;
		top = c.top;
		bottom = c.bottom;
		left = c.left;
		right = c.right;
		isHasBranch = c.isHasBranch;
		isFit = c.isFit;
		card_stamp_time = c.card_stamp_time;
		isOverThre = c.isOverThre;
		isChangePath = c.isChangePath;
		deal_time = c.deal_time;
		originId = c.originId;
		strOriginReaderName = c.strOriginReaderName;
        realId = c.realId;
		return *this;
	}
};

#endif // !YASERVER_CELL_STRUCT_H_