#ifndef TAYLOR_WLS_TDOA_H
#define TAYLOR_WLS_TDOA_H

#include <Eigen/Dense>
#include <SyncTime/Position.h>
#include <memory>
#include <limits>

//#include "classdef.h"
//#include <unordered_map>
#include "../base/base_data_struct.h"
#include "../Functions/Functions.h"

namespace Tdoa{
	using namespace HostServer;
	//
	using namespace Eigen;

	const double DEFAULT_ITERATIVE_ACCURACY = 0.5;			// Ĭϵ
	const unsigned int DEFAULT_ITERATIVE_TIMES = 20;		// Ĭϵ

	class TaylorWls{
	public:
		TaylorWls(){
			is_initial = false;
			this->accuracy = DEFAULT_ITERATIVE_ACCURACY;
			this->iterator_times = DEFAULT_ITERATIVE_TIMES;
		}
		TaylorWls(double accuracy,unsigned int times){
			is_initial = false;
			this->accuracy = accuracy;
			this->iterator_times = times;
		}
		~TaylorWls(){}
	private:
		unsigned int iterator_times;	// 
		bool is_initial;		// Ƿʼ˳ʼ
		double accuracy;		// 

		Position pos;			// 
		Position iter_pos;		// 
	private:
		Matrix<double,Eigen::Dynamic,Eigen::Dynamic,Eigen::DontAlign> anchors;		// վ
		Matrix<unsigned long long,Eigen::Dynamic,1,Eigen::DontAlign> T;				// վʱ

	private:
		//mĹ
		Matrix<double,Eigen::Dynamic,Eigen::Dynamic,Eigen::DontAlign>& pinv(Matrix<double,Eigen::Dynamic,Eigen::Dynamic,Eigen::DontAlign>& m);
		//ɷֲ̫
		double gauss_rand(double mu, double sigma);
		double gauss_rand();

	public:
		double get_accuracy(){return accuracy;};
		void   set_accuracy(const double & accuracy){this->accuracy = accuracy;};

		Position& get_position(){return pos;};
		void set_position(const Position& p){
			pos = p;
		};

		unsigned int get_iterative_times(){return iterator_times;};
		void set_iterative_times(unsigned int times){this->iterator_times = times;}

		// 
		Position& calc_position(std::shared_ptr<algorithm::base::ReceiveDataUnorderedMap>& pRdm);
		// taylor+ȨС㷨
		Position& taylor_wls(Matrix<double,Eigen::Dynamic,Eigen::Dynamic,Eigen::DontAlign>& anchors,Matrix<unsigned long long,Eigen::Dynamic,1,Eigen::DontAlign>& T,const Position& pos,unsigned int size);

		// ʼĳʼ
		void init_position(const Position& pos){
			this->iter_pos = pos;
			this->pos = pos;
			is_initial = true;
		};

		int init_params(std::shared_ptr<algorithm::base::ReceiveDataUnorderedMap> pRdm);	//˵һζλ⣬ÿε㷨ʼվtt
	};
};

#endif