#ifndef YASERVER_CLASSDEF_H_
#define YASERVER_CLASSDEF_H_

#define MAX_LOG_LENGTH 500
#define MAX_DIST_CACHE 2  //5
#define DIST_COUNT 4
#define ANCHOR_COUNT 4

#define MINE_EVENT_COUNT 3
#define SECTION_EVENT_COUNT 6
#define AREA_EVENT_COUNT 5
#define CARD_EVENT_COUNT 88
#define READER_EVENT_COUNT 88

#define KALMAN_OFFSET_COOR 0.01
#define KALMAN_OFFSET_MOVE 1

#define KALMAN_OFFSET_RANGING 0.01
#define KALMAN_INTERVAL 1.0 // Ϊλ

#define KALMAN_OFFSET_COOR_TRI 0.01
#define KALMAN_OFFSET_MOVE_TRI 1
#define KALMAN_OFFSET_RANGING_TRI 0.09
#define KALMAN_INTERVAL_TRI 2.0 //Ϊλ

#define ANTENNA_COUNT 4
#define ADHOC_COUNT 10
#define READER_TIMEOUT 20
#define CARD_LOST_TIME_OUT 30 // (30)
#define CARD_ATTENDANCE_TIMEOUT (60*60)
#define CARD_LOST_TIME_CAL 5 // δյݺûݼ
#define CARD_LOST_TIME_OUT_SPECIAL_AREA 1800
#define READER_SEND_STATE_TIMEOUT 30 
#define LIGHT_SEND_STATE_TIMEOUT 30 
#define OVER_TIME (480 * 60)
#define MAX_SEMACOUNT 64

//㷨
//#define ALGORITHM_TYPE_TOF
//#define ALGORITHM_TYPE_TDOA
//#define ALGORITHM_TYPE_INS		//ʹùߵж
#define ENABLE_MY_LOG
#define ENABLE_DEBUG_PERSON_IN_CAR_LOG 1
#define ENABLE_DEBUG_2D_TEST_LOG 0

#define NEED_DISPLAY_RULES 1  // lemon 2017/08/01
#define NEED_DISPLAY_VALID 0
#define NEED_DISPLAY_INVALID 1
#define PATROL_LEVEL_ID 3

#define INDEXFORRECONEREADER 10 //10ζֻһվգٶΪ0

#define SUSTAINEDOVERSPEED 5 // 5ζǳ٣澯.

#define WRITE_DRIVINGFACE_REAL_PER_TIME 20000

#define STR_LEN_TIME 50

//lemon 2017/10/14
#define DRIVINGFACE_X_CONST 1   //X 
#define DRIVINGFACE_Y_CONST 2   // Y 
#define DRIVINGFACE_XY_CONST 3

#define STARTUP_STATE_COUNT 10
#define SHUTDOWN_STATE_COUNT 5
#define SEC_TO_HOUR 3600.0   

//area
#define AREA_WORK_AREA      1 //
#define AREA_NON_WORK_AREA  0 //ǹ

//card
#define CARD_FRONT_LINE_WORKERS		1 //һ߹
#define CARD_SECONT_LINE_WORKERS	2 //߹

#include <string>
#include <ctime>
#include <map>
#include <iostream>  
#include <string>  
#include <vector>
#include <unordered_map>
#include <deque>
#include <mutex>
#include <thread>
#include <boost/shared_ptr.hpp>
#include <kalman\locate.h>
#include "Filter\KalmanFilter.h"
#include "algorithm\FittingPosition.h"
#include "algorithm\Fit.h"
#include "LocateRecord.h"
#include "algorithm/tdoa/taylor_wls_tdoa.h"
#include "algorithm/base/sensor_manager.h"
//#include "algorithm/AjustPosition.h"
#include <boost/circular_buffer.hpp>
#include "car.h"

struct card;

#define MIN(x,y) (x < y ? x : y)
#define MAX(x,y) (x > y ? x : y)

using namespace std;
using namespace algorithm;

//㷨ʹõĳ
const int MAX_CALC_POINTS = 30;
const int ACCELERATE_INIT_STATE = -10;
const int IDLE_CONFIRM_TIME = 4;
const int LIGHT_CTRL_DELAY = 1000;
const int MAX_REBOUND_COUNTS = 5;
const double INS_WEIGHT = 9.0;			 //ߵȨ
const double UWB_WEIGHT = 1.0;			 //UWBȨ

const double MAX_VECHILE_SPEED = 30.0;	 //˶ٶֵֵλݱ
const double MAX_PERSON_SPEED = 15.0;	 //˿˶ٶֵֵλݱ

const double NEAR_READER = 4.0;
const double MIN_DIFFER_DISTANCE = 10.0; // ʹվУʱжϸýУվľķΧ
const double MIN_IDLE_THRESHOLD = 0.5;
const double VECHILE_ACCELERATE_THRESHOLD = 3; // Уٶֵ
const double PERSON_ACCELERATE_THRESHOLD = 1.5; // Уٶֵ
const int POS_NO_CHANGE_TIMES = 15; // lihongzhen  2017/8/19 λδıÿ0.5룬Լ7
const double CHAMBER_WIDTH = 4.0;			//ָǰչĿȣλΪ
const double VEHICLE_WIDTH = 10.0;
const double TOF_HEIGHT_ERROR = 2;					//tofλʱĸ߶λΪ
const double READER_SYNC_INTERVAL_TIME  = 0.2;		//վͬŵʱֵ
const int CONFIRM_ON_VEHICLE_COUNTS = 3;			//ϳȷϴ
const int CONFIRM_OFF_VEHICLE_COUNTS = 3;			//³ȷϴ
const double THRE_MOVING_READER_DISTANCE = 3.0;		//˿ƶվľֵ³ͨ
const double THRE_RELATIVE_SPEED = 3.6;				//˿ƶվӦĳٶֵλΪ3.6km/h

#define OFFSET_THRE_IN_LINE 1	//жǷ߶ϣΪ1ףisinline
#define ZERO_PRECISION 1E-3		//Ϊľ
#define HIGH_ZERO_PRECISION 1E-6		//߾ж

//added by zhuyf 2018/07/06
const double MAX_SPEED = 1.87;		///ƶٶȣ1.67m/s Լ 6km/hǵ0.2׵Ҫ+0.2
const int IGNORE_H_DISTANCE = 10;	//ɺԸ߲ľ룬ڴ˾ʱ߲ԺԲ
const double ABSOLUTE0 = 0.00001;
const int H = 2;					//ߵĸ߲Ǹֵ
const double E = 0.2;				//ྫ
const int SIMULATOR_CARD_START_NO = 60000;
const uint64_t MAX_SMALL_READER_SIZES = 10;

enum ALARM_FLAG{
	//AF_CARD_OVER_COUNT = 1,
	//AF_CARD_AREA_OVER_COUNT,
	AF_CARD_OVER_TIME,
	AF_CARD_OVER_SPEED,
	AF_CARD_AREA_OVER_SPEED,
	AF_CARD_AREA_OVER_TIME,
	AF_CARD_LOW_POWER,
	AF_CARD_LOW_POWER_SERIOUS,
	AF_CARD_AREA_FORBIDDEN,
	AF_AREA_OVER_COUNT,
	AF_AREA_OVER_TIME,
	AF_AREA_FORBIDDEN,
	AF_CARD_OVER_COUNT,
	AF_CARD_NEAR_WARNING_POINT,//lemon	
	AF_CARD_NEAR_DRRIVINGFACE_VEHICLE, //lemon 2017/08/01
	AF_CARD_NEAR_GEOFAULT,
	AF_CARD_MOTIONLESS
};

enum AREA_TYPE
{
	AREA_TYPE_FORBIDDEN = 3,	// 
	AREA_TYPE_NO_COVER = 1000,	// Ǹ򣬳źʧ󣬶λǸ
	AREA_TYPE_SPECIAL = 1001	// ֻǰʶǷʾͼ,ֳ
};

enum EDIT_TYPE_ID{
	ET_INSERT = 0, // 
	ET_UPDATE,	   // ޸
	ET_DELETE      // ɾ
};
//
enum VECHILE_TYPE_ID
{
	VT_DIGGINGCOAL_MACHINE=25,
	VT_DRIVINGFACE_MACHINE=26
};
enum ALARM_TYPE_ID
{
	ATID_OVER_COUNT_PERSON = 1,
	ATID_POWER,
	ATID_OVER_COUNT_VEHICLE
};

enum STATUS_DEVICE{
	STATUS_DEVICE_NORMAL = 0,
	STATUS_DEVICE_ERROR
};

enum STATUS_CARD
{
	STATUS_NORMAL = 0,				//
	STATUS_ERROR = 1, 
	STATUS_ERROR_SERIOUS = 2,

	STATUS_POWER_LOWER = 1,			//
	STATUS_POWER_LOWER_SERIOUS = 2, //
	STATUS_OVER_TIME = 4,			//ʱ
	//STATUS_OVER_COUNT = 1,
	STATUS_OVER_SPEED = 8,			//
	STATUS_AREA_OVER_TIME = 16,		//ʱ
	//STATUS_AREA_OVER_COUNT = 1,
	STATUS_AREA_OVER_SPEED = 32,	//
	STATUS_AREA_FORBIDDEN = 64,		//
	STATUS_HELP = 128,				//
	STATUS_HELP_DEALED = 256,		//Ѵ
	STATUS_CALL = 512,				//
	STATUS_LOST = 1024				//ä
	//STATUS_ERROR_DEALED,
};

enum STORE_CARD_DATA_FLAG{
	HIS_LOCATION = 0,
	HIS_RAW_DATA,
	HIS_AREA_LOCATION_ENTER,
	HIS_AREA_LOCATION_LEAVE,
	RPT_ATTEND_DOWN,
	RPT_ATTEND_UP
};

enum STORE_MINE_DATA_FLAG{
	ALARM_MINE_OVER_COUNT_PERSON_START = 0,
	ALARM_MINE_OVER_COUNT_PERSON_END,
	ALARM_MINE_OVER_COUNT_VEHICLE_START,
	ALARM_MINE_OVER_COUNT_VEHICLE_END
};

enum STORE_LIGHT_DATA_FLAG{
	ALARM_LIGHT_FAULT_START= 0, 	//Ͽʼ
	ALARM_LIGHT_FAULT_END,			//Ͻ
	ALARM_LIGHT_NETWORK_START,		//Ͽʼ
	ALARM_LIGHT_NETWORK_END,		//Ͻ
	ALARM_LIGHT_CONTROL_FAILE		//ʧ
};

enum STORE_SECTION_DATA_FLAG{
	ALARM_SECTION_START = 0, // θ澯ʼ
	ALARM_SECTION_END // θ澯
};

enum LIGHT_STATE{
	LIGHT_NORMAL = 0, // 
	LIGHT_FAULT, // 쳣
	LIGHT_NETWORK_ERROR,  // 
	LIGHT_CONTROL_ERROR   // ʧ
};

enum LOCATE_TYPE
{
	LT_COORDINATE = 0, // ʹ궨λ
	LT_READER // ʹ÷վλ
};

enum FILTER_TYPE{
	NO_FILTER = 0,		// ʹ˲
	FILTER_KALMAN = 1	// ʹkalman˲
};

enum SECTION_STATE{
	SECTION_STATE_NORMAL = 0,		//
	SECTION_STATE_BUSY = 1,			//æ
	SECTION_STATE_CONGESTION = 2	//ӵ
};

enum LIGHT_SHAPE{
	INIT_SHAPE=0,
	RED_CIRCLE_SOLID = 1,	//ɫʵԲ
	RED_CIRCLE = 2,			//ɫԲ
	RED_CROSS = 3,			//ɫ
	GREEN_UP = 4,			//ɫϼͷ
	GREEN_DOWN = 5,			//ɫ¼ͷ
	GREEN_LEFT = 6,			//ɫͷ
	GREEN_RIGHT = 7,		//ɫҼͷ
	RED_SPARK = 8,			//ɫ˸
	GREEN_SPARK = 9,		//ɫ˸
	GREEN_ALL_ON=10,		//ɫȫ
	GREEN_ALL_OFF=11,		//ɫȫ
	RED_ALL_ON=12,			//ɫȫ
	RED_ALL_OFF=13			//ɫȫ
};

enum LIGHT_STREAM{
	INIT_STREAM = 0,
	UP_STREAM = 1,		//
	DOWN_STREAM = 2	//
};

enum LIGHT_COLOR{
	COLOR_RED = 1, // ɫ
	COLOR_GREEN = 2 // ɫ
};

enum LIGHT_CTRL_STATE{
	CTRL_STATE_AUTO = 1, //  Զ
	CTRL_STATE_MANUAL = 2 // ֶ
};

enum LIGHTS_SELECT_TYPE
{
	LST_ALL_LIGHTS = 0, // е
	LST_ALL_UP_LIGHTS = 1, // 
	LST_ALL_DWON_LIGHTS = 2,// 
	LST_SOME_LIGHTS = 3 // ָ
};

enum AREA_PROPERTY{
	MAIN_TUNNEL = 0, // 
	BRANCH_TUNNEL = 1 // ֧
};

enum OUTPUT_POS{
	CENTRAL_POS = 0, // 
	LEFT_POS,  // 
	RIGHT_POS  // 
};

enum PATROL_STATE
{
	PS_NORMAL = 0, // 
	PS_EARLY, // 絽
	PS_LATE,  // ٵ
	PS_NON_ARRIVAL // δ
};

enum PATROL_STAY_STATE
{
	PSS_NORMAL = 0, // 
	PSS_TOO_LONG,   // ͣ
	PSS_TOO_SHORT   // ̫ͣ
};

enum ALGO_RETURN_VALUE{
	DIST_COUNT_LESS_THAN_TWO = 10001,
	DIST_COUNT_LESS_FOR_TIMESTAMP_ERROR,
	DIST_COUNT_LESS_FOR_SYNC_NUM_DIFFER_FIVE,
	DIST_COUNT_CARD_CUR_CT_LESS_LAST,

	ALGO_CALC_SOLUTION = 30001,
	ALGO_CALC_NO_SOLUTION_WITH_TWO_DATA,
	ALGO_CALC_ONE_DATA,

	SOLUTION_NO_SOLUTION = 40001,
	SOLUTION_NOT_EXIST_READRE,
	SOLUTION_NEAR_READER,
	SOLUTION_TWO_SOLUTION,
	SOLUTION_ERROR_STREAM,
	POSITION_INVALID,
	SOLUTION_IDLE_STATUS,

	CHECK_PERSON_ACCE_OVER_SPEED = 50001,
	CHECK_VEHICLE_ACCE_OVER_SPEED,
	CHECK_VEHICLE_OVER_SPEED,

	KALMAN_FILTER_LONG_INTERVAL = 60001,

	ALGO_USE_KALMAN_FILTER = 70001,
	ALGO_DIVIDE_ZERO = 80001,
};

extern unsigned int g_nAlgoFailedCounts[ALGO_LOC_TOTAL];	//ȫֵͳд
extern unsigned int g_nAlgoFailedCycleCounts[ALGO_LOC_TOTAL];	//ָڵͳƴ
extern DWORD g_ullCurTime;
extern unsigned long long m_Start_time;
#define ALGORITHM_FAILED(nType) { \
	g_nAlgoFailedCounts[nType]++; \
}

struct AlgoFailedMsg{
	std::string strCardId;
	int nCardStamp;
	int nType;
	SYSTEMTIME st;
	bool bStatus;

	AlgoFailedMsg(){
		strCardId = "";
		nCardStamp = 0;
		nType = 0;
		bStatus = false;
	}
};

enum DEVICE_TYPE{
	DT_BIG_READER		= 1,	// վ
	DT_SMALL_READER		= 2,	// Сվ
	DT_CARD_READER		= 3,	// վ
	DT_CTRL_READER		= 4,	// ͨŷվ
	DT_LIGHT			= 5,	// ̵
	DT_SPEAKER			= 6,	// 澯
	DT_TURNOUT			= 7,	// 
	DT_LED				= 8,	// ʾ
};

enum CALL_STATE{
	CALL_NONE = 0,			//޺Ϣ
	CALL_SUCCESSED = 1,		//гɹ
	CALL_ING = 2,			//
	CALL_FAILED = 3,		//ʧ
};

enum CALL_CARD_TYPE
{
	CCT_CALL_ALL = 0, // ȫԱ
	CCT_CALL_APOINT, // Ա
};

enum LOCATEDATATYPE // λ
{
	LDT_TOF = 0,		//TOF 
	LDT_TDOA,			//TDOA
	LDT_BROAD,			//Braodcast
	LDT_TOF_INS,
	LDT_TDOA_INS
};

enum LOCATE_DATA_NUMS{
	ONE = 1,
	TWO,
	THREE,
	FOUR
};

enum Orientation{
	LEFT = 0,
	UP,
	RIGHT,
	DOWN,
	LEFT_UP,
	LEFT_DOWN,
	RIGHT_UP,
	RIGHT_DOWN,
};

enum INS_REQUEST_STATUS{
	NO_INS_REQUEST = 0,		//У׼
	YES_INS_REQUEST		//У׼
};

enum SEND_CAL_DATA_STATUS{
	CAL_DATA_ALL = 0,		//У׼
	CAL_DATA_POS,			//У׼
	CAL_DATA_ANGLE			//У׼Ƕ
};

enum PERSON_ON_VEHICLE_STATUS{
	PERSON_OFF_VEHICLE = 0,
	PERSON_ON_VEHICLE
};

struct OnVehicleData{
	int counts;
	std::map<string,int> person_cards;

	OnVehicleData(){
		counts = 0;
	}
};

struct SQLTHREAD_DATA//дݿ̴߳ݵĲ
{
	char* pText;//ݿַָ
	int nRepeatTimes;//ѾԼ
};

struct _point{ // 
	double x;
	double y;
	double z;

	_point(){
		x = y = z = 0;
	}

	_point(double a,double b,double c){
		x = a;
		y = b;
		z = c;
	}

	_point(double a,double b){
		x = a;
		y = b;
		z = 0;
	}
};

struct TimePosition{
	time_t cur_time;
	_point p;

	TimePosition(){
		cur_time = time(NULL);
		p.x = p.y = p.z = 0;
	}

	TimePosition(double x_,double y_){
		cur_time = time(NULL);
		p.x = x_;
		p.y = y_;
	}
};

struct AlgoParamData{
	_point ant[2];		//˫
	uint16_t ct;		//ǰ˫߲Ϣ
	double distance[2];	//˫ߵĲ
	uint32_t anchor_id;	//վ

	AlgoParamData(){
		ant[0].x=ant[0].y=ant[1].x=ant[1].y = 0;
		ct = 0;
		distance[0] = distance[1] = 0;
	}
};

struct sync_data{
	double x;
	double y;
	double z;

	double vx;
	double vy;
	double vz;

	int sync_num;	//ͬ
	bool update;

	std::shared_ptr<nspLocate::LocateRecord> locate;

	sync_data(){
		x = 0.0;
		y = 0.0;
		z = 0.0;
		vx = 0.0;
		vy = 0.0;
		vz = 0.0;
		sync_num = 0;
		update = false;
		locate = nullptr;
	}

	sync_data& operator=(sync_data&tmp){
		x = tmp.x;
		y = tmp.y;
		z = tmp.z;
		vx = tmp.vx;
		vy = tmp.vy;
		vz = tmp.vz;
		sync_num = tmp.sync_num;
		update = tmp.update;
		locate = tmp.locate;
		return *this;
	}
    inline bool operator == (const sync_data& rhs) const
    {
        return x == rhs.x &&
            y == rhs.y &&
            vx == rhs.vx &&
            vy == rhs.vy &&
            sync_num == rhs.sync_num &&
            update == rhs.update;
    }
};

struct _call_info_card
{
	int card_id;        // п
	int card_type;      // ͣȫԱԱ
	int call_level;     // мһ㡢
	string str_card_id;  // пţ
	time_t start_time;   // ʼʱ
	int time_out;        // ʱλ
	//bool is_success;
	int call_state;      // ״̬ںСгɹ
};
//typedef map<std::string, _call_info_card*> CallInfoCardMap;
typedef map<std::string, std::shared_ptr<_call_info_card>> CallInfoCardMap;

struct _call_info_reader
{
	bool is_call_all;       // ͣ ȫԱԱ
	bool is_start_call;		//true,ʼ;false,ȡ
	BYTE call_level; // һ㣬
	//int call_type; 
	int cards_count;        // еĿ0ΪȫԱ
	int time_out;           // ʱ
	time_t start_time;      // ʼʱ
	CallInfoCardMap mpCard;  // пб
};

typedef map<int, std::shared_ptr<_call_info_reader>> CallInfoReaderMap;

struct _call_info_user
{
	std::string user_name; // ָû
	CallInfoReaderMap mpReader; // зվб
};
typedef map<string, std::shared_ptr<_call_info_user>> CallInfoUserMap;

// վʱ䶨
struct ReceiveData{
	unsigned int reader_id;		// վ
	unsigned short antenna_id;  // ߺ
	long long rec_time_stamp;	// վʱ䣬һ7ֽڵ޷
	int special;
	double x;	//վx
	double y;   //վy
	double z;   //վz
	ReceiveData(){
		reader_id = -1;
		antenna_id = -1;
		rec_time_stamp = 0;
		x = y = z = 0.0;
		special = -1;
	};
};

// վtof
struct ReceiveDataTof:public ReceiveData{
	double distance;
	ReceiveDataTof(){
		distance = 0.0;
	};
};

struct INFO_PRE{
	int t;
	long long detaT;
	double dist;
	int ant;
	int sta_num;
};

//TOFλʱοݽṹ
struct TOF_REFER_DATA{
	unsigned int nCardTimeStamp;	// ct
	long long llDeltaTime;			// 
	double dDistance;				// 
	unsigned int nAntennaIndex;		// վ
	unsigned int nReaderId;			// վid
	double x;						// οx
	double y;						// οy
	double z;						// οz
	int a;							// ٶ״̬

	TOF_REFER_DATA(){
		nCardTimeStamp = 0;
		llDeltaTime = 0;
		dDistance = 0.0;
		nAntennaIndex = nReaderId = 0;
		x = y = z = 0.0;
		a = 0;
	}
};

//Ľṹ
struct SOLUTION{
	double x[3];
	double y[3];
	double z[3];
	int nCount;

	SOLUTION(){
		for (int i =0;i<3;i++)
		{
			x[i] = y[i] = z[i] = INVALID_COORDINATE;
			nCount = 0;
		}
	}
};

//ߵУ׼ݽṹ(x,y),Ƕangle
struct CAL_DATA{
	float x;
	float y;
	float angle;
	int status;
	int card_type;			//
	std::string card_id;	//id

	CAL_DATA(){
		x = y = angle = 0.0f;
		status = 0;
		card_type = 0;
		card_id = "";
	}
};

// úʼλ
struct CoalFaceStartPos
{
	float x;          // ʼλx
	float y;          // ʼλy
	time_t rec_time;  // ʼʱ
};

//۲Ϣ
class CoalMiningArea
{
public:
	//
	INT coalface_id;
	//۲˵1
	double x1;
	double y1;
	//۲˵2
	double x2;
	double y2;
	//Ϊ˵ľ뷶Χ
	double distance;

	//úƫλ
	double m_x_offset;
	double m_y_offset;

	CoalMiningArea():m_x_offset(0.0),m_y_offset(0.0){}
};

//úѭʵм
class CoalMiningRegularCycle
{
public:
	//Id
	INT vehicle_id;
	//
	INT coalface_id;
	//Ƿʼ
	bool IsWorking;
	// δͷ/β
	bool bNoTarget;
	//뵶
	bool bHalfKnife;
	//Ŀ
	INT tgPointNum;
	//˶ true-ͷ-βfalse-β-ͷ
	INT bDirection;
	//ϴηλʱ
	time_t  last_time;
	//ʼʱ;
	time_t start_time;
	//¼Сʱ
	time_t  mindis_time;
	//ĿС
	double mindistance;
	//ƻ
	double schedule_times;
	//ʼλ
	double start_x;
	double start_y;
	//λ
	double end_x;
	double end_y;
	//ʱλü¼
	string pos_record;
};

//úÿϸ
class CoalminingRegularCycleDetail
{
public:
	INT vehicle_id;// ;
	//
	INT coalface_id;
	time_t start_time;//ʼʱ;
	time_t end_time;//ʱ;
	int dept_id;//ӦID;	
	double start_x;//ʼx;
	double start_y;//ʼy;
	double end_x;//x;
	double end_y;//y;
	int move_direction;
};

//ڶλķվ˹ϵ
struct DrivinfaceReaderTopology{
	uint64_t m_big_reader_id;		//վid
	uint64_t m_small_reader_id[MAX_SMALL_READER_SIZES];	//0ΪСվid1Ϊм̷վid
	uint64_t m_counts;		//¼ЧʹõСվݣm_small_reader_idС

	DrivinfaceReaderTopology():m_big_reader_id(0),m_counts(0){
		for (uint64_t i = 0;i<MAX_SMALL_READER_SIZES;++i)
		{
			m_small_reader_id[i] = 0;
		}
	}
};

//úھ˾
struct VehicleDriverPos
{
	VehicleDriverPos()
		:PointNum(0)
		,Sum_x(0.)
		,Sum_y(0.)
		,isOn(false)
	{

	}
	//ʼʱ
	time_t starttime;
	//߶ӦĳǷ񿪻
	bool isOn;
	//λ
	int PointNum;
	//x
	double Sum_x;
	//y
	double Sum_y;
};

//ú˾ĶӦϵ
struct DeptVehicleDriver
{
	//ID
	int Dept_id;

	//ú˾ĶӦϵ
	std::map<int ,std::vector<int>> CoalMiningDriver;

	//˾ĶӦϵ
	std::map<int ,std::vector<int>> DrivingDriver;
};

//˾ͻ澯
struct WorkfaceDriverAlarm
{
	//ID
	int Vehicle_id;
	//澯
	double dist;
	//澯ʱ
	int dist_time;
};

class Mine;
class Area;
class SpecialAreaEntry;
class DrivingfaceRender;
class DrivingfaceCard;
class DrivingfaceWarningPoint;
class VehicleTypeAttRule;
class Reader;
class Card;
class MapInfo;
class Dept;
class BanShift;
class OccLevel;
class ReaderPath;
class PatrolPoint;
class PatrolTask;
class LeaderArrange;

class Section;
class Chamber;
class Light;
class LightsGroup;
class LightCallInfo;
class StorePostion;

class LandmarkInfo;
class MapDirectionInfo;
class HandUpVehicle;
class MovingReader;
class WarningPoint;

typedef map<string, std::shared_ptr<Card>> CardMap;
typedef map<int, std::shared_ptr<Area>> AreaMap;
typedef map<int, std::shared_ptr<DrivingfaceWarningPoint>>DrivingfaceWarningPointMap;
typedef map<int,std::vector<std::shared_ptr<DrivingfaceWarningPoint>>> DrivingfaceWarningPointMapAll;
typedef map<uint64_t,std::list<std::shared_ptr<WarningPoint>>> WarningPoint_Map;
typedef map<int, std::shared_ptr<SpecialAreaEntry>> SpecilaAreaEntryMap;
typedef map<int, std::shared_ptr<DrivingfaceRender>> DrivingfaceRenderMap;
typedef map<string,std::shared_ptr<DrivingfaceCard>> DrivingfaceCardMap;
typedef map<int, std::shared_ptr<Reader>> ReaderMap;
typedef map<int, std::shared_ptr<MapInfo>> MapInfoMap;
typedef map<int, std::shared_ptr<MapDirectionInfo>>MapDirectionInfoMap;
typedef map<int, std::shared_ptr<LandmarkInfo>>LandmarkInfoMap;
typedef map<int, std::shared_ptr<Dept>> DeptMap;
typedef map<int, std::shared_ptr<BanShift>> BanShiftMap;
typedef map<int, std::shared_ptr<OccLevel>> OccLevelMap;
typedef map<int, string> AlarmTypeMap;
typedef map<int,std::shared_ptr<ReaderPath>> ReaderPathMap;
typedef map<int,std::shared_ptr<ReaderPath>> TOFReaderPathMap;
typedef unordered_map<int,std::shared_ptr<ReaderPathMap>> TDOAReaderPathMap;
typedef unordered_map<std::string, std::shared_ptr<_coordinate>> DistMap;
typedef map<unsigned long long ,std::shared_ptr<ReceiveData>> ReceiveDataMap;
typedef vector<std::shared_ptr<ReceiveDataTof>> ReceiveDataTofVector;
typedef unordered_map<unsigned long long ,std::shared_ptr<ReceiveData>> ReceiveDataUnorderedMap;
typedef map<int,std::shared_ptr<Section>> SectionMap;	//·Ϣ
typedef map<int,std::shared_ptr<Chamber>> ChamberMap;	//Ϣ
typedef map<int,std::shared_ptr<Light>> LightMap;		//̵Ϣ
typedef map<int,std::shared_ptr<LightsGroup>> LightGroupMap;	//̵Ϣ
typedef map<unsigned int, std::shared_ptr<PatrolPoint>> PatrolPointMap;
typedef map<unsigned int, std::shared_ptr<PatrolTask>> PatrolTaskMap;
typedef map<std::string, std::shared_ptr<PatrolTask>> PatrolTaskCheckMap;
typedef map<unsigned int, std::shared_ptr<PatrolPoint>> PatrolPointMap;
typedef map<unsigned int, std::shared_ptr<PatrolTask>> PatrolTaskMap;
typedef map<std::string, std::shared_ptr<PatrolTask>> PatrolTaskCheckMap;
typedef deque<std::shared_ptr<StorePostion>> QueStrorePos;
typedef map<std::string, std::shared_ptr<LeaderArrange>> LeaderArrangeMap;
typedef map<int,string> WorkTypePermissionMap;
typedef map<int,int> RulesMap; //lemon 2017/08/01
typedef map<int, std::shared_ptr<VehicleTypeAttRule>> VehicleTypeAttRuleMap;
typedef map<std::string,std::shared_ptr<CAL_DATA>> CardCalData;	//һԪstringǿţڶԪǴ˿У׼
typedef map<int,std::shared_ptr<CardCalData>> CalDataMap;	//еУ׼ݣintΪվţڶԪͨ˷վҪ·пУ׼
typedef map<int,std::map<int,std::shared_ptr<Reader>>> BigSmallReaderMap;	//keyΪվϢvectorΪ˴վµдСվϢ

//typedef std::map<int,std::shared_ptr<MonkeyCarInfo>>  MonkeyCarInfoMap;
typedef std::map<std::string,std::shared_ptr<HandUpVehicle>> HandUpVehicleMap;
typedef std::map<int,std::shared_ptr<MovingReader>> MovingReaderMap;

typedef map<int,std::shared_ptr<CoalMiningArea> >  CoalMiningAreaMap;  //۲Ϣ
typedef map<int,std::shared_ptr<CoalMiningRegularCycle>> CoalMiningRegularCycleMap;//úѭʼźͲ
typedef map<int, int> CoalWorkfaceVehicleMap; // ú복󶨱

typedef map<string, std::shared_ptr<Card>> CoalDrvingfaceCardMap;      // ú/
typedef map<string, int> CardVehicleMap;  // ͿŶӦ
typedef map<string, int> CardWorkfaceMap; // ͹Ӧ

typedef map<int,std::shared_ptr<VehicleDriverPos>> VehicleDriverPosMap;
typedef map<int,std::shared_ptr<DeptVehicleDriver>> DeptVehicleDriverMap;
typedef map<int,std::shared_ptr<WorkfaceDriverAlarm>> WorkfaceDriverAlarmMap;

typedef struct key_value_pair
{
	int key;
	int value;
	struct key_value_pair* next;
}KeyValuePair;

typedef struct statistic_data_str
{
	int index;
	KeyValuePair* data_info; 
	struct statistic_data_str* next;
}StatisticDataStr;

struct DistQueMapItem
{
	WORD cardstamp;
	DistMap distmap;
};

struct MeetingInfo
{
	std::string keyValue; // ϣСǰ0020000001011 0020000001022 - > 1011-1022
	std::string card_id_first; // һ
	std::string card_id_second; // ڶ
	double distance; // ֮ľ
	int reduce_counter; // 
};

typedef deque<DistQueMapItem> DistQueMap;
typedef map<std::string, MeetingInfo> MeetingInfoMap;
// ͼ
class MapInfo{
public:
	MapInfo(void);
	~MapInfo(void);
public:
	int map_id;
	string map_path; // ͼļ·
	string map_name; // ͼ
	double map_width; // ͼ
	double map_height; // ͼ߶
	double map_scale; // ͼ
	int map_type; // ͼļͣ

	AreaMap map_area_list; // ͼϵб
	ReaderMap map_reader_list; // ͼϵķվб
	ReaderMap map_ctrl_reader_list; // ͼϵĿƷվб
	CardMap map_card_list_person; // ͼϵԱб
	CardMap map_card_list_vehicle; // ͼϵĳ
	ChamberMap map_chamber_list; // ͼϵ
	SectionMap map_section_list; // ͼϵ·
	LightMap map_light_list; // ͼϵĽͨ
	LightGroupMap map_light_group_list; // ͼϵĽͨƵ
};

class LandmarkInfo
{
public:
	int landmark_id; // ر
	string landmark_name; // ر
	int map_id; // ͼ
	int area_id; // 
	double x;
	double y;
	double z;
};

class MapDirectionInfo
{
public:
	MapDirectionInfo(){};
	~MapDirectionInfo(){};
public:
	int map_direction_id; // ͼ
	int map_id; // ͼ
	int north_angle; // ǰͼϷ뱱ļнǣжϵǰͼĸǱ
};
// 
class Area  // 
{
private:
	std::vector<std::string> split(std::string str,std::string pattern); // pathָɵ㼯
	double get_vertex(std::string src); // 
public:
	Area(void);
	~Area(void);
	void init_border(string sz_path); // ʼ߽
	bool is_in_polygon(_point p); // жϵǷڶ
	bool is_special(); // ǷΪ
public:
	int map_id;  // ڵͼ
	int area_id; // 
	string area_name; // 
	string area_type_name; // 
	string path; // 
	int area_type_id; // 
	/*
	*@brief
	ǷΪʶ
	#define AREA_WORK_AREA      1 //
	#define AREA_NON_WORK_AREA  0 //ǹ
	*/
	bool m_is_work_area;
	// Ա
	int over_count_person; // 
	int over_time_person; // ʱ
	int under_count_person; // С
	int under_time_person; // Сʱ
	// 
	int over_count_vehicle; 
	int over_time_vehicle;
	int under_count_vehicle;
	int under_time_vehicle;
	double over_speed_vehicle;		//ٶֵ

	int polygon_count; // 
	_point* polygon; // 

	// 
	int count_person; // ǰ
	int count_vehicle; // ǰ
	int count_card; // ǰ

	// Ƿд
	int is_att; // 0 ͣ⣬1 ͣ
	bool is_area_over_time_person; // ʱ
	bool is_area_over_time_vehicle; // Աʱ
	int count_area_over_time_person; // ʱ
	int count_area_over_time_vehicle; // ʱ
	time_t time_over_time_person; // ʼʱʱ
	time_t time_over_time_vehicle; // ʼʱʱ

	bool is_area_over_count_person; // ԱԱ
	bool is_area_over_count_vehicle; // Ա
	int count_area_over_count_person; // ԱԱ
	int count_area_over_count_vehicle; // Ա
	time_t time_over_count_person; // ʼʱ
	time_t time_over_count_vehicle; // ʼʱ

	// ΪʱЧ
	bool is_area_forbidden_person; // Ƿ˽
	bool is_area_forbidden_vehicle; // Ƿг
	int count_area_forbidden_person; // 
	int count_area_forbidden_vehicle; // 복
	time_t time_forbidden_person; // ʼʱ
	time_t time_forbidden_vehicle; // ʼʱ

	std::shared_ptr<CardMap> area_card_list_person; // ڵԱ
	std::shared_ptr<CardMap> area_card_list_vehicle; // ڵĳ
	std::shared_ptr<CardMap> area_card_list_over_speed; // ڳٵĳ

	INT64 m_event_list[AREA_EVENT_COUNT]; // ¼Id
};


class WarningPoint
{
public:
	int warning_point_id;
	std::string warning_point_name;
	std::vector<NAMESPACE_POINT::point> vp;
	std::string to_string()
	{
		std::stringstream ss;
		ss<<"point_id:"<<warning_point_id<<" name:"<<warning_point_name;
		for (const auto &p:vp)
			ss<<"("<<p.x<<","<<p.y<<")";
		ss<<"-----";
		return ss.str();
	}
};

// Σյ㶨
class DrivingfaceWarningPoint
{
public:
	int warning_point_id;  // Σյ
	string warning_point_name;
	int driving_face_id; // 
	float point_x; // Σյλ
	float point_y;
	float point_z;
	float warning_threshold; // ޣ룩
	int is_valid; // ΣյǷЧ
};

class SpecialAreaEntry
{
public:
	SpecialAreaEntry(){}
public:
	double start_point_x;  // ڣԽ
	double start_point_y;
	double start_point_z;
	double end_point_x;
	double end_point_y;
	double end_point_z;
	int    special_area_id; // 
	std::string car_type;
	int	   union_area_id;
};

class DrivingfaceRender
{
public:
	DrivingfaceRender(){}
public:
	INT    drivingface_id;
	INT    reader_id;
	double vertical_distance;
	double x;
	double y;
	double z;
};

// 뿨Ϣ
class DrivingfaceCard
{
public:
	DrivingfaceCard():m_total_ref_point_dist(0.0){
		x = y = z = m_schedule_work_times = m_schedule_tunnelling_times = m_drifting_footage_unit = m_fOffset=0.0;
		drivingface_id = area_id = m_overcount = m_mapId = m_drivingface_type = m_relay_small_reader_id = m_small_reader_id = m_big_reader_id = 0;
		m_old_state = m_cur_state = false;m_sensor_id.clear();
		m_vt_ref_point_list.resize(0);
	}
	~DrivingfaceCard(){}
public:
	double x;
	double y;
	double z;
	INT drivingface_id;
	string card_id;
	INT area_id;
	float warning_threshold;
	int m_overcount;
	int m_mapId;
	int m_drivingface_type;
	int m_relay_small_reader_id;		//мСվ
	int m_small_reader_id;				//Сվ
	int m_big_reader_id;				//վ
	int m_dept_id;						//
	double m_schedule_work_times;		//ƻʱ
	double m_schedule_tunnelling_times;	//ƻ
	double m_drifting_footage_unit;		//ļ
	bool m_old_state;					//֮ǰľ״̬
	bool m_cur_state;					//ǰľ״̬
	double m_driver_dist;   //泵˾澯룬
	int  m_driver_dist_time;//泵˾ĸ澯

	std::vector<op::point> m_vt_ref_point_list;
	double m_total_ref_point_dist;	//׼֮ۼƾ
	double m_fOffset;

	std::vector<int> m_sensor_id;
	struct TAirSensor{
		TAirSensor()
			:bigger(-1),count(0),sum(0),ct(-1),stime(0),flag(false),rid(0)
		{}
		void clear()
		{
			count=sum=0;stime=0;flag=false;
		}
		std::array<op::point,2> ant;
		std::array<double,2> dist;
		int8_t bigger;
		uint32_t count,sum;
		uint16_t ct;
		uint64_t stime;
		bool flag;
		uint16_t rid;
		std::list<double> his_data;
	};
	TAirSensor m_tas;
	bool timeout()
	{
		time_t t=time(NULL);
		return m_tas.flag && t-m_tas.stime>10*60;
	}
	bool check_location_reversal(std::string & str)
	{
		time_t t=time(NULL);
		time_t tval= t-m_tas.stime;
		bool f=false;
		if (tval !=0 && m_tas.sum*1.0/tval > 0.8 && m_tas.count*1.0/m_tas.sum <0.2)
			f=true;
		char buf[1024]={0};
		sprintf(buf,"[reverse_alarm_checking]%s,count:%d,sum:%d,val:%d,s:%.2f,v:%.2f,alarm:%d",
			card_id.c_str(),m_tas.count,m_tas.sum,tval,(m_tas.sum*1.0/tval),(m_tas.count*1.0/m_tas.sum),f);
		str=buf;
		return f;
	}
	void make_reverse_condition(int16_t antid,uint16_t ct,double d)
	{
		m_tas.dist[antid]=d;
		if(m_tas.ct == ct){
			m_tas.sum++;
			int b=-1;
			if (m_tas.dist[0]>m_tas.dist[1]) b=0 ;else b =1;
			if(b==m_tas.bigger) m_tas.count++; //ϸĵ
		}
		m_tas.ct = ct;
	}
	void set(const op::point &p0,const op::point &p1,int id)
	{
		int8_t b=0;
		m_tas.ant[0].set(p0);m_tas.ant[1].set(p1);
		op::point bp(x,y);
		double d0=bp.dist(p0);double d1=bp.dist(p1);
		if(d0>d1)b=1;else b=0;
		if (m_tas.bigger!=-1 && b!=m_tas.bigger){
			m_tas.count=m_tas.sum=0;m_tas.stime=time(0);
		}
		m_tas.bigger=b;m_tas.rid=id;
	}
	bool push(double d){
		bool f=true;
		m_tas.his_data.push_back(d);
		if (m_tas.his_data.size()==3){
			double da=0;
			for (const auto &d:m_tas.his_data){
				if(da>d || d-da<0.004){f=false;break;}
				da=d;
			}
			m_tas.his_data.pop_front();
		}
		else f=false;
		return f;
	}
	op::point &operator[](int i){return m_tas.ant[i];}
	const op::point &operator[](int i)const {return m_tas.ant[i];}
	void set_true(){m_tas.flag=true;m_tas.stime=time(NULL);}
	bool warning(){return m_tas.flag;}
	bool empty(){return m_tas.his_data.empty();}
	double back(){return m_tas.his_data.back();}
	void clear_sensor(){m_tas.clear();}
	int reader_id(){return m_tas.rid;}

};

// Ԥ
class Adhoc
{
public:
	Adhoc();
	~Adhoc();
public:
	int adhoc_id; 
	double x;
	double y;
	double z;
	int idx; // ڵ㼶
};

// 
class Antenna
{
public:
	Antenna(void);
	~Antenna(void);
public:
	int antenna_id;
	double antenna_x;
	double antenna_y;
	double antenna_z;
	double antenna_angle;
};

class BaseArea{
public:
	BaseArea(){
		m_nPolygonCount = 0;
		m_pPolygon = NULL;
	}
	~BaseArea(){
		if (m_pPolygon)
		{
			delete[] m_pPolygon;
			m_pPolygon = NULL;
		}
	}
public:
	int init_border(string path);
	bool IsInPolygon(_point p);
private:
	double GetVertex(std::string src); // 
	std::vector<std::string> Split(std::string str,std::string pattern);
public:
	int m_nProperty;
	int m_nPolygonCount;
	_point* m_pPolygon;
};
// ߽綨
class BoundaryArea:public BaseArea{
public:
	BoundaryArea(){
		boundary_area_id = map_id = reader_id = 0;
		name = path = "";
	};
	~BoundaryArea(){};
public:
	int boundary_area_id; 
	int map_id;
	int reader_id;
	string name;
	string path;
};

// վ
class Reader
{
public:
	Reader(void);
	~Reader(void);
public:
	int reader_id; // վ
	string reader_name; // վ
	int device_type_id; // 豸ͣվͨŷվͨƵ
	int pos_state; // λ״̬ 1ϣ2
	string ip;
	double reader_x; 
	double reader_y;
	double reader_z;
	double reader_angle;

	double reader_interval_time; // վݼλ

	int map_id; // ڵͼ
	int area_id; // 
	double map_scale; // 

	time_t rec_time; 
	time_t reader_time;		// վʱ
	time_t lost_time;		// ʧʱ
	time_t last_send_time;	// ǰ˷ʱ
	int temperature;		// ¶
	int tick_count;			// 
	int reader_state;		// ״̬ 0 , 1 
	int reader_state_old; 
	int dimension;			// ָվλͣһάλάλάλ
	int sync_level;         // ʱͬ
	unsigned long long sync_rootId; // ʱͬվţͬʱڶڵ

	std::shared_ptr<Antenna> ant[ANTENNA_COUNT]; // 
	std::shared_ptr<Adhoc>   adhoc[ADHOC_COUNT]; // 豸
	map<int,_point> readerCoveragePath; // վǷΧtofʹ
	bool bIsInitCoverage;
	int m_nIsSpecial; // ǷΪվλվ4ڣվͽλ㶨λڷվ
	bool init_ctrl_reader_state;	//ΪƷվʱһҪô˿Ʒվµĺ̵״̬

	INT64 m_event_list[READER_EVENT_COUNT]; // ¼Id

	unsigned int reader_package_end_pos;				// վݰλ
	std::string	last_parse_card_id;						// һ

	std::shared_ptr<BoundaryArea> pBoundaryArea; // λվ߽磬ڶάλվ

	bool is_parent;					// ǷΪipĴվ
	unsigned int parent_anchor_id;  // ΪipĴվ߹ڴվµСվָվid

	std::vector<TimePosition> m_vt_his_position;
	int is_simulation_card;			// ʾ˷վǷģɳ,1ʾģ⳵0ʾ޷ģ⳵
	bool b_simulation_status;		// վģ⳵״̬Ϊtrueʾʼģ⣬falseʾվģ⳵
	time_t m_start_simulation_time;	// Сվʼģ⳵ʱ
	uint8_t reader_dir;				// վ򣬶ڴСվ
	uint8_t relay_counts;			// Сվм

	bool m_bNeedPowerAlarm;			//ǷҪվع澯
public:
	string get_state_text();		// ȡ״̬Ϣ
};

class StorePostion
{
public:
	StorePostion(){
		x = y = z = 0;
		GetLocalTime(&save_time);
	};
	~StorePostion();

	double x, y, z;
	SYSTEMTIME save_time;
};


// 
class Card : public NAMESPACE_POINT::card_interface
{
public:
	//Card(void);
	~Card(void);
	Card(string cardid, int cardtype,double z_offset);

public:
	CRITICAL_SECTION m_csCard;
	bool m_bigCarFlag;
	double m_overSpeed;
	double m_overAreaSpeed;
	bool is_registered; // ǷעᣬǷ¼ݿ⣬û¼뵱жϣ
	virtual int push_optimized_data(NAMESPACE_POINT::loc_point&lp);
	virtual int getCardType();
	virtual bool smoothFlag();
	virtual bool getBigCarFlag();
	virtual const std::string& cardId();
	virtual const uint64_t CtTime();
	virtual const int getX();
	virtual const int getY();
	virtual double getv();
	virtual int getAreaId();
	virtual int getAcc();
	virtual void do_alarm(const std::size_t ow);
	virtual void PrintString(const std::string &&str);
	virtual const uint64_t  get_last_recv_time();
public:
	Fit fit_x; // ϵλ
	Fit fit_y;
	int card_type; //  0x01, 0x02
	string card_id;
	int m_indexCardSpeed;//ټһٸ澯
	int m_indexCardSpeed_normal;//ٶһȡٸ澯
	int m_indexMineOverSpeed;//ټһٸ澯
	int m_indexMineOverSpeed_normal;//ٶһȡٸ澯
	// Ա
	int level_id; // 
	int worktype_id;// lemon 2017/07/31 Ϊvehicle_type_id
	int vehice_type_id; // 

	// 
	boost::circular_buffer<int> m_cb_state;         // 洢ӲϴĿػߵ
	bool m_bOpen;                                   // ú/״̬ 
	time_t m_startup_time;                          // ú/ʱ
	int m_nCardId;                                  // 
	time_t m_lastrecv_time;                         // ϴյʱ
	double m_fScheduleStartupTime;                  // ú/ƻʱ
	std::vector<CoalFaceStartPos> m_vecLoc;         // úλʷ켣

	/*
	*@brief
	һ߹˻߹˱ʶ
	#define CARD_FRONT_LINE_WORKERS		1 //һ߹
	#define CARD_SECONT_LINE_WORKERS	2 //߹
	*/
	BYTE m_staff_type;

	// Ա
	int id; // ţԱ
	int dept_id; // 
	int occ_id; // ְid
	int group_id; // 	
	int need_display;// lemon 2071/08/01 ǷWebʾ
	int power_alarm_display;//lemon 2018/01/15 ͵澯ʶ1 0
	std::string vehicle_category_id;//lemon 2018/04/11 ͣ˳ϳֳ
	bool power_change_flag;//
	int shift_type_id; // Աִ߳еİ
	std::string m_staffName;
	std::string m_deptName;
	time_t		m_dbTimeInterval;
	string driver_id;	//ǳ˾id
	int light_id; // ƵĵƱ
	int shift_id; // γ
	SYSTEMTIME deal_time; // ߼ʱ
	SYSTEMTIME enter_area_time; // ʱ
	//
	int m_indexForRcvOneReader;
	//driving face write database time
	ULONGLONG drive_face_location_write_time;
	ULONGLONG drive_face_location_end_time;
	//SYSTEMTIME down_time;
	time_t rec_time; // ʱ
    time_t last_correct_position_info_time; // lyl temp add: һνλϢɹʱ
    int data_source_al_route13; // lyl temp: ·13ۼƴ
	time_t down_time; // 뾮ʱ
	time_t att_start_time_latest; // һδźתΪźŵʱ䣬пڿпڷǿ lihongzhen  2017/8/17 17:20
	time_t att_end_time_latest; // һδӷǿ뿼ʱ lihongzhen  2017/8/17 17:23

	time_t up_time; // ʱ
	time_t enter_reader_time; // վʱ
	time_t low_power_time; // Ϳʼʱ
	double x; // λ
	double y;
	double z;
	//鿴ǷΪʼֵǲв
	bool is_drivingface_Initialization;

	// ֻоϵĿЧ
	int driving_face_id; // 
	double driving_face_cur_shift_start_x; //cur shift start position
	double driving_face_cur_shift_start_y;
	double driving_face_cur_shift_start_z;

	double driving_face_cur_shift_x; //cur shift real point
	double driving_face_cur_shift_y;
	double driving_face_cur_shift_z;

	double drving_face_cur_shift_max_speed;

	double a; // ϴζλʱĽǶ
	int t; // ϴζλʱʱ
	double m_oldv;// lemon 2017/10/26
	double v; //ٶ
    double final_v; // ̰߳ȫ, ֹ v мֵ
	double mileage; // ̣ϴαʱľ
	double z_offset; // ʶվߵĸ߶Ȳ
	bool init_postion; // ǷʼλϢ㷨õ
	bool is_first_location; // ǷΪһζλ㷨õ
	int is_driving_face_start; // ΪʱжǷ

	double right_x,right_y,right_z;		//ֱָλұƫƵx,y,z
	double left_x,left_y,left_z;		//ֱָλƫƵx,y,z

	double last_x; // ϴεĶλλ
	double last_y;
	double last_z;

	double stored_x; // 洢ݿеλ
	double stored_y;
	double stored_z;

	double output_x; // 㷨λ
	double output_y;

	double last_vx; // ϴεٶ
	double last_vy;

	int state;	// 0  32bit,ÿbitһ״̬:
	// һλ 0x01 ³ʱ, ڶλ 0x02 ʱ, λ 0x04 , λ 0x08, 
	// ״̬ϡ͵
	int state_moving; // ˶״̬ 0 ֹ1 ˶, 2
	int state_meeting; // ᳵ״̬movingstateϲʾ 3ᳵ4ᳵ5

	// ͡ С
	int status_over_time; // 0 δʱ1 ʱ
	int status_over_speed; // 0 δ٣1 
	int status_area_over_time; // 0 δʱ 1 ʱ
	int status_area_over_speed; // 0 δ٣ 1 
	int status_area_forbidden; // 0 δ 1 
	int status_help; // 0 δȣ 1 ȣ 2 Ѵ
	int status_help_cancel; //cancle help request
	int status_call; // 0 δ 1 
	int status_power; // 0 1 
	int status_lost; // 0 δä1024 ä״̬

	int map_id; // ǰͼ
	double map_scale; // ͼ
	int map_id_old; // ϴβڵͼ
	int area_id; // ǰ	
	int pre_area_id;

	bool m_area_changed; // л
	int landmark_id; // رϢ
	double landmark_dis; // رľ
	int landmark_direction; // رķ
	int reader_id; // ǰվ

	Reader* p_reader; // һձݵķվԳΪ׼
	std::shared_ptr<ReaderPathMap> pTofReaderPathMap; // tofվͼ
	std::shared_ptr<TDOAReaderPathMap> pTdoaReaderPathMap; // tdoaվͼ
	map<unsigned long long,std::shared_ptr<_coordinate>> mp_dists_locate; // 㷨dist¼õݣ
	_coordinate last_locate; // һμõλ
	_coordinate origin_locate; // ԭʼĶλ
	_coordinate error_locate; // Ķλ

	QueStrorePos _storepostions; // 㷨洢Ķλ
	DistQueMap _dists; // 㷨dist
	unsigned short time_stamp_max; // ʱҪ㶨λʱ
	unsigned short time_stamp_cal; // ct ֵλctֵ
	unsigned short time_stamp_cal_last; // 㷨λʱ

	int m_nFilterType; // ˲
	int m_nLastLocateT; // λʱͬ
	int m_nCalcSyncNum;	//㷨еͬţͬźͿʵʱͬŲһһ
	int m_nSyncNumInList;	//ӶȡĴ5ͬ
	int m_nStream;			//С
	int m_direction;    // 

	int m_nLightGroupId; // id

	int m_nMoveDirection;		//1Ϊ˶-1Ϊ˶
	int m_nIsRailroad;			//ǷΪй쳵0Ϊ޹쳵1Ϊй쳵
	int m_nOutputPosState;		//0Ϊм꣬1Ϊƫ꣬2Ϊƫ
	bool bIsBack; // ǷΪ

	bool bInSpecailArea; // Ƿ
	bool issent;		// true ѷͻˣfalse ݣҪͻ
	bool issaved;		// true ѱ浽ݿ⣬false µĿڼ¼Ҫ浽ݿ
	bool isdealed;		// Ѿ
	bool isreceive;		// յ
	bool is_deal_by_algo;		//Ƿ񾭹㷨
	bool is_hist; // ǷΪʷмص
	bool m_bUseFilter; // Ƿʹ˲
	bool isoutput;				//Ƿjson
	bool is_red_light; // Ƿ񴳺
	bool is_mine_over_time;		// Ƿ³ʱ
	bool is_mine_over_speed;    // Ƿ³
	bool is_area_over_time;		// Ƿʱ, ʱֳʱԱʱ
	bool is_area_over_speed;	// Ƿ

	time_t time_area_over_time; // ʱʼʱ
	time_t time_over_time;		// ³ʱʼʱ
	time_t time_area_forbidden; // ʱ
	time_t time_over_speed;		// ٿʼʱ
	time_t time_area_over_speed; // ٿʼʱ
	time_t time_low_power; // ͵ʼʱ
	time_t time_red_light;		//ʱ
	time_t last_locate_time;	// λʱ

	void reset();				// ״̬
	void resetAllBaseInfo();   //ûϢ

	void set_reader(std::shared_ptr<Reader> preader);
	void add_dist(std::shared_ptr<_coordinate> dist);
	void cal_pos_by_cache(); // ûݼλ
	int dist_cache_size(); // ȡݸ
	void remove_dist_head(); // ɾеһԪ
	string concat(int reader_id, int ant_id); // ѷվźߺƴΨһʶ
	time_t get_working_time(); // ȡʱ
	int get_state(); // õ״̬
	int get_state_moving(); // ˶״̬
	double get_speed(); // ȡٶ
	void set_speed(double v); // ٶ
	int get_effictive_dist_count(int offset = 0); // ȡ㷨dist
	void set_reader_path(std::shared_ptr<ReaderPathMap> rpm, std::shared_ptr<TDOAReaderPathMap> trpm); // õͼ
	//int get_direction(double x1,double y1,double x2,double y2);
	void get_coordinate(); // λ꣬㷨
	void get_coordinate(int cnt);

	int const PosState(); // ¾״̬
	void PosState(int val); // þ¾״̬
	void PosStateOld(int val); // һ¾״̬жǷ״̬ıʱȽ
	bool is_pos_state_changed(); // \״̬仯
	int const StateBiz(); // ҵ״̬

	int new_algo_tof_1d(int cnt);
	double CalculateX(int L1, int L2, int last_ct, int ct, double last_x, double dis1, double dis2, double last_dis1, double last_dis2, double next_dis1, double next_dis2);
	double Card::CalculateX(double L1, double L2, int last_ct, int ct, double last_x0, double dis1, double dis2, double last_dis1, double last_dis2, double next_dis1, double next_dis2);
	_point CalculateX(const AlgoParamData* pData,_coordinate& lc);
	int Sign(double x);
	DistQueMap::iterator get_iterator(DistQueMap::iterator it);

	INT64 m_event_list[CARD_EVENT_COUNT]; // ¼Id
public://lemon
	int m_warning_point_id;  // Σյ
	bool m_isWarning; // վ澯ʹ
	double m_minDistanceToWarningpoint; // Σյ
	double m_warning_threshold; //
	bool m_CardHasBeenInDrivingfaceAlarm; // ǷѷΣյ澯
	int m_DrivingfaceAlarmFlag; // Ǽ¼Ա澯
	int m_drivingface_index;    //վ֮þͳƲ
	int m_drivingface_index_del;
//Ŀǰ澯ģƣҪʹ
	bool m_warning_point_alarm;
	double m_disToWarningPoint;
	int	   m_wp_id;
	int m_workface_index;    //վ֮þͳƲ
	int m_workface_index_del;
public:
	//add by zhuyf 2017/10/18
	int recevie_by_moving_reader;			// ˶ԣͳƱƶվյĴ
	int person_on_card;						// ϳ״̬0Ϊ³1Ϊϳ
	int satisfy_on_vehicle_counts;			// ˿ϳ״̬ͳƴ
	int satisfy_off_vehicle_counts;			// ˿³״̬ͳƴ
	double relative_speed;					// ٶ
	double min_distance;					// С룬
	std::string possible_vehicle_id;			// ܵĳ
	std::string vehicle_id;					// ˿ԣĿǰ˿

	std::shared_ptr<CardMap> mp_person_in_vechicle_list;	// ԳԣͳϳԱб

	bool package_is_over;		//վڴ˿ݰ꣬꼴ɵ㷨м		
	bool no_need_add_dist;		//Ҫ뵽_dists

	double recv_signal_power; // յźǿ
	
public:
	//ʹ
	unsigned long long  m_ct_time; // ʱ䣬ʱٶ
	
	int m_positon; 
	ULONGLONG m_getOnTime;

public:
	CardMap mp_list_over_count; 
	//lemon 2017/08/01
	inline double getDrivingfaceCulValue(){return m_drivingface_distance_cul_values;}
	inline double getDrivingfaceLimitValue(){return m_drivingface_distance_limit_values;}
	inline void	 setDrivingfaceCulValue(double cvalue){m_drivingface_distance_cul_values = cvalue;}
	inline void  setDrivingfaceLimitValue(double lvalue){m_drivingface_distance_limit_values = lvalue;}

	//lemon 2017/08/16
	double m_drivingface_start_x;
	double m_drivingface_start_y;
	double m_drivingface_start_z;
	std::string m_drivingface_start_time;

	double m_curshift_finish_length;
	double m_cur_total_finish_length;
	//lemon 2017/09/22  ȫϢ
	string store_data_card( int tag,double x =0,double y =0);

	//zhuyf 2018/08/30
	double m_max_distance;	//СվվԶ
	op::point m_max_p;		//ԶĶλ
	time_t m_record_cycle_start_time;	// ¼ڵĿʼʱ
	double m_record_avg_dist;		//ھϢƽֵ
	double m_record_min_dist;		//Сֵ
	double m_record_max_dist;		//ֵ
	unsigned int m_record_totals;	//ܼ¼
	bool m_b_first_record;	//
	std::string m_str_record;	//
	std::vector<TimePosition> m_cb_position;	//洢һڵꣻ
	op::point m_base_position;
	bool m_b_first_calc;
private:
	double m_drivingface_distance_cul_values;
	double m_drivingface_distance_limit_values;
public:
	//㷨ز
	bool is_algo_first_location;		//ʾ㷨ĵһζλ
	bool is_idling; // ǷΪ״̬
	bool is_del_data; //Ƿɾ
	int idle_count; // жΪ״̬ĴֵٶΪ0
	int ins_req_status_algo;	//㷨ߵ״̬

	DistMap dist_1d; // ͬ㷽ʽĻdist
	DistMap dist_2d;
	DistMap dist_3d;
	DistMap distmap;

	std::shared_ptr<nspLocate::LocateRecord> locate;
	std::list<std::shared_ptr<POS>> idle_pos_list; // жλб

	//2017/11/28 add by zhuyf
	std::shared_ptr<Tdoa::TaylorWls> pTaylorWls;
	std::vector<std::shared_ptr<HostServer::Position>> avg_coordinate;	// tdoaάλʱͳǰ5ƽ꣬㿪ʼʹüٶȻٶȹ
	bool is_use_acc_filter;

	std::shared_ptr<algorithm::base::SensorManager> pSensorManager;
	algorithm::base::Sensor<double>* pAcceSensor;
	algorithm::base::Sensor<double>* pGyroscopeSensor;

	void algo_tof(int cnt);
	int  algo_tof_1d(int cnt);		// tofһάλ
	int  algo_tof_2d(int cnt);		// tofάλ
	int  algo_tof_3d(int cnt);      // tofάλ

	//tdoa㷨
	void  algo_tdoa(int cnt);
	int  algo_tdoa_1d(int cnt);		// tdoaһάλ
	int  algo_tdoa_2d(int cnt);		// tdoaάλ
	int  algo_tdoa_3d(int cnt);		// tdoaάλ
	
	int inspect_coordinate(int acce_state); // λ

	int save_card_data(); // Ϊʶֵ
	void algo_calc_offset();		//ƫ

	double x_offset_after();        //ƫƺX
	double y_offset_after();        //ƫƺY
	double z_offset_after();        //ƫƺZ
	bool algo_is_same_direction(double x,double y,double z);	//˴η

	int CheckDistData(int cnt);
	int AssembleDistData(std::shared_ptr<ReceiveDataMap> pRdm);		//tdoaװ
	int AssembleDistData(map<unsigned long long, std::shared_ptr<_coordinate>>& p_dist_locate);	//tofװ
	int GetDeltaT(map<unsigned long long,std::shared_ptr<_coordinate>> dl); // ȡζλ֮ʱ
	int SaveCardAlgoData(std::shared_ptr<POS>& pos); // 㷨
	int SaveTofData(const std::shared_ptr<POS> pos);  // tof㷨
	int SaveTdoaData(const std::shared_ptr<POS> pos);  // tdoa㷨
	int SaveOriginDataBeforeFilter(std::shared_ptr<POS> pos); // 㷨˲ǰļĽ
	int ChooseOneSolution(std::shared_ptr<ReceiveDataMap> pRdm, std::vector<std::shared_ptr<POS>> udm_pos, std::shared_ptr<POS>& pos);// Ψһ
	int calibration_pos_data(std::shared_ptr<POS> pos);			//Уݣ浽pos

	int optimization_pos(std::shared_ptr<POS> pos);				//Żλ
	int kalman_filter_process_tdoa(std::shared_ptr<POS> pos); // tdoa˲
	int kalman_filter_process_tof(std::shared_ptr<POS> pos);  // tof˲
	int position_data_filter_by_direction(std::shared_ptr<POS> pos,map<unsigned long long, std::shared_ptr<_coordinate>>& p_dist_locate);	//ͨͬһվԭ෽бȽжϽǷԤ

	int CheckSolution(std::shared_ptr<POS>& p);					// tdoa һάλʹã֤ΨһϷԣٶȡٶ
	void saveToSyncNumDataList(int sync_num, double pixelX, double pixelY, double speedX, double speedY, bool updated); // ͨУ, 浽 m_syncNumList 
	int CheckSulutionByStream(std::shared_ptr<POS> p);			// ʹ÷ã޸ֵ
	int GetStream(double x1,double y1,double x2,double y2);		// з

	int get_direction(double x1,double y1,double x2,double y2); //򣬷
	int CalcPositionBySpeed(std::shared_ptr<POS>& pos,double v); // ͨٶȼλ
	bool CheckStreamUniformity(double x1,double y1,double x2,double y2,int nStream); // 鵱ǰλnStreamǷһ
	bool IsExistPath(int left,int right); // жվ֮Ƿڵͼtdoa㷨
	int CopySolution(std::shared_ptr<POS> source,std::shared_ptr<POS>& dest); // 

	//std::shared_ptr<nspLocate::LocateRecord> locate;
	bool IsIdleStatus(std::shared_ptr<POS> pos); // жǷΪ״̬
	bool IsRebound(std::shared_ptr<POS> pos);		//жǷ
	virtual bool CheckPositionValid(const std::shared_ptr<POS> pos);		//Ч
	bool CheckPositionValid(const double& x,const double& y);
	double GetDeltaT();		//ȡʱֵ

	int get_dimension(); // ȡλͣһάάά
	int split_dist_data(); // ָdist¼
	int deal_position_boundary(_point& p);		//ά߽紦
	bool position_is_in_boundary(_point p);		//pǷڱ߽e
	_point mapping_position_to_boundary(_point p); //ӳ˵㵽߽ϵĵ

	int check_solution_tdoa_2d(std::shared_ptr<POS>& p);
	int save_tdoa_data_2d(std::shared_ptr<POS>& p);		//tdoaάλ
public:
	//tofر
	time_t time_cur_algo;				// distݽеʱ
	time_t time_last_tof;				// ϴtofλʱ
	int reader_id_algo;					// 㷨ʱķվ
	bool is_send_ins_check;

	int  get_position_by_one_distance(std::shared_ptr<TOFReaderPathMap> trpm,std::shared_ptr<POS>& pos,const TOF_REFER_DATA refer_data);
	bool CheckSolutionTof(std::shared_ptr<POS>& pos);		//ͨٶȼٶȼ鶨λǷȷ
	int  get_ref_data_from_dists(map<unsigned long long, std::shared_ptr<_coordinate>> tmp_dists_locate,const int& key,TOF_REFER_DATA& refer_data);

private:
	void set_reader_path_tof(std::shared_ptr<ReaderPathMap> rpm);			// tof·
	void set_reader_path_tdoa(std::shared_ptr<TDOAReaderPathMap> trpm);		// tdoa·
public:
	list<sync_data> m_syncNumList;
	std::list<std::shared_ptr<POS>> his_idle_pos;

	bool b_long_interval;	//һζλļʱ10s
	int diff_direction_counts; // д
	int maxSyncTimes; // վʱͬʱ
public:
	// ˲㷨
	std::unique_ptr<CKalmanFilter> m_pKalmanFilter;

	int acce_cur_state;		//㷨б浱ǰٶ״ֵ̬ԭڶ߳accelerate_stateaccelerate_state_last״̬ܱ仯
	int acce_last_state;	//㷨бһμٶ״̬

	double ins_weight;	//ٶȼ״̬Ȩ
	double uwb_weight;	//uwb״̬Ȩ

	std::list<double> vt_his_speed;

	int FindDistMap(int cardstamp); // 鿴distǷдͬct
	int KalmanFilterProcess(std::shared_ptr<POS>& pos); // ˲

	void EnableFilter(int nType); // ˲
	
	bool isRebound(std::shared_ptr<POS> pos);			//жǷ
public:
	bool b_save_pos;
	//ڳʱ޷λʹ㷨
	std::list<std::shared_ptr<POS>> his_pos;	//֮ǰ5Ϣ

	bool is_ref_pos;		//жǷΪο
	bool is_fit_pos;
	bool have_fit_pos;
	bool have_long_fit_pos;
	bool is_over_interval;		//ڱmodify_card_speedеǰʱͿʱǷ񳬹ָʱ״̬

	int count_idle;			//ͳжٴû仯ˣжϳǷ٣ͳ5
	int cur_fit_nums;		//ǰϴݷhis_pos
	int cur_ref_totals;
	int count_change_direction; // ͳƷıĵλ3Σıʻ

	double fitting_v[REF_POSITION_NUM];
	double fitting_ct[REF_POSITION_NUM];
	double fitting_x[REF_POSITION_NUM];
	double fitting_y[REF_POSITION_NUM];

	double fit_new_x[FIT_POSITION_NUM];
	double fit_new_y[FIT_POSITION_NUM];

	//ڶ
	std::list<std::shared_ptr<POS>> long_his_pos;	//֮ǰ20ϢϢUWBλϢ
	double long_fitting_ct[REF_POSITION_NUM];
	double long_fitting_x[REF_POSITION_NUM];
	double long_fitting_y[REF_POSITION_NUM];
	double long_fit_new_x[FIT_POSITION_NUM*4];
	double long_fit_new_y[FIT_POSITION_NUM*4];

	int UpdateFittingData(std::shared_ptr<POS> pos);	//ϻ
	int CalcFittingData(list<std::shared_ptr<POS>> & list_pos);								//
	//double CalcFittingData_ForMonkeyCar(list<std::shared_ptr<POS>> & list_pos);
	//int GetStream_Monkeycar(double x1,double y1,double x2,double y2);
	int CalcLongFittingData();
	int CalcFittingData(int ret,std::shared_ptr<POS>& pos);	
	int CalcLongFittingData(int ret,std::shared_ptr<POS>& pos);	
	int GetPosFromFittingData(std::shared_ptr<POS>& pos); 
	std::shared_ptr<POS> GetPosFromFittingData();						//ݻȡλ
	int CheckSolutionByFit(int ret,std::shared_ptr<POS>& pos); // ֤ĺϷ
	int CheckSolutionBySpeed(std::shared_ptr<POS>& pos); // ٶ֤ĺϷ
    bool need_reset;// temp add by lyl: 㷨ǷҪ
    int cell_station_error_num; // temp add by lyl: վ쳣
    int speed_limit_after_reset;  // temp add by lyl: ú, 㷨ٶֵܿ

	bool CheckCardCtValid();	//鿨ctЧ
public:
	int state_biz;					//ҵ״̬/ʱ/
	int pos_state;					// λ״̬0ʼ1£2ϣ3վ
	int pos_state_old;
	int pos_state_count;			// ǰλ״̬ȷϴ
	int pos_state_confirm_times;	// ¡״̬ȷϴĬΪ1

public: 
	// ɼĵײ
	unsigned short time_stamp_last;		// λʱ
	
	int accelerate_state_last;	// һμٶ״̬
	int power_state_last;		// 
	int ins_direction;			// һεĹߵϳɷ
	int reader_tickcount;		// վݵļ
	unsigned short time_stamp;	// λʱ
	unsigned short time_center_stamp;	// λʱ
	int ranging_type;			//  toftdoa
	int accelerate_state;		// ٶ
	int antenna_id;				// ߺ
	int power_state;			// 
	int sync_num;				// վͬ
	int n_pos_no_change_times;  // lihongzhen  2017/8/19 λδ仯
	bool b_pos_change;			// λ÷˸ı
	bool b_enter_intersection;	// Ƿ·
	int strength;				// źǿ

	double antenna_angle;		// ߽Ƕ
	double distance;			// 
	int64_t flying_time;		// ʱ
	
	string str_his_time; // վյʱʱ
	string str_rec_time; // ɼյݵʱ
public:
	//Ϣ
	int call_type_id; // ͣȫԱԱ
    int call_type; // м һ㡢
	std::vector<int> vt_deal_call_reader_id; // еķվб
	time_t recv_call_time;	//յеʱ

public:
	//ߵ
	//tofйߵ
	int ins_request_check;							//uwbߵݵЭйߵУ׼״ֵ̬0Ϊ1ΪУ׼
	int ins_cal_type;								//·У׼ͣ0·У׼ǶȺ꣬1·У׼꣬2·У׼Ƕ
	bool is_check_ins;								//ǷУ׼ߵ
	double ins_gyp_angle;							//У׼ǽǶ
	std::shared_ptr<POS> cur_ins_pos;				//ߵϴ
	std::shared_ptr<POS> ins_gyp_pos;				//У׼Ĺߵʼ
	std::list<std::shared_ptr<POS>> lt_uwb_pos;		//洢У׼ʱ̵uwbλ
	std::list<std::shared_ptr<POS>> lt_ins_pos;		//洢У׼ʱ̵insλ


	int deal_ins_cal_data();				//ߵУ׼
	int calc_slope(std::shared_ptr<POS> start,std::shared_ptr<POS> end,double & slope);
public:
	//Լͳƹ
	AlgoFailedMsg m_afmData;
	//add by zhuyf 2018/06/28
	//ڲԿᷢȣ600Ͽ䷢ͺ
	bool is_no_send_help;			

public:
	//Բغ
	int OutputCmdLog(int n);

	double dTestDelatT;		//ʱ
	double dTestDistance;		//εĶλľ
    //position_optimizer
 //   virtual std::string get_id();
//	virtual unsigned long long get_m_ct_time();
public: 
	// lihongzhen  2017/9/25 ԭ˲㷨
	CalLocation* cal_location; // άλ㷨
	Point2* p2_anchors; // άλ

	CalLocation3* cal_location3; // άλ㷨
	Point3* p3_anchors; // άλ

	std::shared_ptr<_coordinate>* p_dists;
	std::shared_ptr<_coordinate>* p_dists_locate;
	bool is_init_kalman; // Ƿѳ˲״̬

	void add_dist_ex(std::shared_ptr<_coordinate> dist);
	void resetKalmanInfo(); // þɰkalman˲λϢ


	bool is_anchor_changed; // λķվûб仯仯ˣҪ״̬
	void get_coordinate_old(int cnt); 
	void get_coordinate_2d(int cnt); // άλ㷨,˲
	void get_coordinate_2d_nofilter(int cnt); // άλͶӰ㷨
	void get_coordinate_3d(int cnt); // ά㷨⣬˲
	void set_anchors(int cnt); // ò붨λķվλ
	int get_effictive_dist_count_ex(); // ȡЧ붨λ㷨dist¼

	virtual int algo_tof_raw_1d(const DistMap& dm);
	virtual const std::vector<std::shared_ptr<_coordinate>> calc_locate_tof_raw_1d(map<unsigned long long, std::shared_ptr<_coordinate>> p_dists_locate) const;
	virtual int get_antenna_xyz(int reader_id, int antenna_id,double& x,double& y, double& z);
	virtual int get_key(double x, double y, double& key);

public:
	std::weak_ptr<card> m_card_ptr;
	inline void set_card_Ptr(std::shared_ptr<card>  ptr)
	{
		m_card_ptr = ptr;
	}

	inline void resetPtr(){m_card_ptr.reset();}
	//׷β
	double m_arg;//0x12345678
	void make_arg();
	uint64_t m_last_time;
	NAMESPACE_POINT::line_v m_line;
public:
	//ʿ
	double m_schedule_work_time;	//úƻʱ
	double m_schedule_mine_times;	//úƻ
	double m_work_face_width;		//úڹĿ

	void calc_tunnel_boring_machine_pos(const op::point& p);
};

// 
class BanShift
{
public: 
	BanShift();
	~BanShift();
	BanShift(int id, std::string s, std::string e, int tid);
	int shift_id; // α
	int shift_type_id; // Ʊ
	std::string start_time; // οʼʱ
	std::string end_time; // νʱ
};

// 쵼
class LeaderArrange
{
public:
	LeaderArrange( string cardid);
	~ LeaderArrange();

	int staff_id; // Ա
	string card_id; // ʶ
	int shift_id; // 
	int shift_type_id; // 
	time_t starttime; // οʼʱ
	time_t endtime; // νʱ
};

// 
class Dept
{
public:
	Dept(){};
	~Dept(){};
	Dept(int id, string name);
private:
public:
	int dept_id;
	string dept_name;

	CardMap dept_card_list_person;
	CardMap dept_card_list_vehicle;
};

// ְ񼶱
class OccLevel
{
public:
	OccLevel(){};
	~OccLevel(){};
	OccLevel(int id);
private:
public:
	int occlevel_id;

	CardMap level_card_list_person;
	CardMap level_card_list_vehicle;
};

/*
* ͼ·
*/
class ReaderPath{
public:
	ReaderPath(){
		bIsInit = false;
		nRealCalcPoints = 0;
		x[0] = x[1] = y[0] = y[1] = 0;
		for(int i = 0;i < MAX_CALC_POINTS;i++){
			px[i] = py[i] = pz[i] = 0;
		}
	}
public:
	//TOFԣx,yʾ1,2߶Ӧ
	//TDOAԣx,yʾF1,F2ͬڷվi,i+1
	int nRealCalcPoints;
	double x[2];
	double y[2];
	double z[2];
	double px[MAX_CALC_POINTS];
	double py[MAX_CALC_POINTS];
	double pz[MAX_CALC_POINTS];

	bool bIsInit;
};

//̵
class Light{
public:
	int m_nID;			//̵id
	int m_nMapID;		//ͼid
	int m_nReaderID;	//վid
	int m_nAreaID;		//id
	int m_nSectionID;	//·id
	int m_nLightsGroupID;		//̵id
	int m_nPort;		//վ֮ͨŵ·
	int m_nState;		//̵Ƿ״̬0ã1
	int m_nOldState;
	int device_type_id;	//豸

	double x;	//x
	double y;	//y
	double z;	//z

	std::string m_strIP;	//̵ip
	std::string m_strName;	//̵
	std::string m_strLabel;

	time_t rec_time;
	time_t last_send_time;
public:
	Light();
	~Light(){}
public:
	int get_light_state();

public:
	int m_nStream;		//0ΪУ1Ϊ
	
	int m_nColor;		//0x01 ɫ, 0x02 ɫ
	int m_nShape;		// ״ 0x01 ʵԲΣ0x02 ԲΣ0x03 Σ0x04 - 0x07 Ҽͷ0xFF ˸
	int m_nStateBiz;	//0Ϊ1Ϊϣ2Ϊʧܣ3Ϊƹ
	int m_nIsCtrl;		// 豸״̬ 0x01 Զƣ0x02ֶ

	time_t alarm_start_time;
};

//Ʋ
struct RunRedLight
{
	//ǰ̵Ƶĵƺţ
	int32_t m_group_id;
	//ǰ̵Ƶĵƺţ
	int m_light_id;
	//id
	int m_vehicle_id;
	//id
	int32_t m_area_id;
	//ʱ
	std::string m_time;
};
// 
class LightsGroup{
public:
	int m_nID;
	int m_nState;

	bool m_bIsUsed;

	std::string m_strName;
	std::string m_strLabel;
public:
	int m_nSectionId;		//ڵ·
	std::string m_strVechileId;		//ƴ˵ĳid
	map<int,std::shared_ptr<Light>> mp_lights_list;
public:
	LightsGroup();
	~LightsGroup(){};

public:
	bool isExist(std::shared_ptr<Light> pLight);
	bool isAllLightColor(int nColor);
};

//
class Chamber:public BaseArea{
public:
	int m_nID;	//ұ
	int m_nState;		//ʹ״ָ̬Ƿڿ
	int m_nIsUsed;		//Ƿг
	int m_nSectionID;	//·ID
	int m_nMapID;		//ͼID

	std::string m_strPath;	//
	std::string m_strName;	//
	std::string m_strLabel;	//

public:
	Chamber();
	~Chamber();
};

//·
class Section:public BaseArea{
public:
	int m_nID;
	int m_nMapId;

	std::string m_strPath;
	std::string m_strName;
	std::string m_strLabel;
public:
	int m_nState;	//0---1---æ2---ӵ

	time_t alarm_start_time;

	ChamberMap mp_champer_list;
	LightMap mp_light_list;
	CardMap mp_vehicle_list;
	CardMap mp_staffer_list;

	INT64 m_event_list[SECTION_EVENT_COUNT];
public:
	Section();
	~Section(){}

public:
	bool is_has_chamber();		//ǷδʹõĶ
	int get_section_state();	//·״̬
	int get_section_vehicle_counts();	//·ڳ
	int get_section_staffer_counts();	//·Ա
};

// Ѳ
class PatrolTask
{
public:
	PatrolTask();
	~PatrolTask();

private:
public:
	int patrol_task_id; // Ѳ
	int patrol_path_id;  // Ѳ·
	string card_id; // 
	string starffer_id; // Ա
	time_t start_time; // ʼʱ
	time_t end_time;  // ʱ
	PatrolPointMap mpPoint; // Ѳб

	bool is_in_cur_point; // Ƿڵǰλ
	int cur_point_idx; // ǰѲ
	int state; // Ѳ״̬
	int stay_state; // ͣʱ״̬
	int duration_stay; //ͣʱ
	time_t enter_time; // ýڵʱ
	time_t leave_time; // 뿪ǰڵʱ
};

// Ѳ
class PatrolPoint
{
public:
	PatrolPoint();
	~PatrolPoint();
private:
public:
	int idx; // ·е
	int patrol_point_id;
	int map_id;
	double x; // ΧԲ
	double y;
	double z;
	double ranging; // 뷶Χ

	int duration_last;  // ϸڵʱ
	int duration_stay_min; // ڵСʱ
	int duration_stay_max;  // ڵʱ
	int duration_ranging; // ϸڵʱƫ
};

enum EVENT_TYPE{ // ¼
	ET_UNKNOWN = 0,
	ET_OVER_COUNT_PERSON = 1, // ԱԱmp_card_list_over_count_person
	ET_OVER_COUNT_VEHICLE = 2,    // ³Աmp_card_list_over_count_person

	ET_AREA_OVER_COUNT_PERSON = 3,	// ԱԱ
	ET_AREA_OVER_COUNT_VEHICLE = 4,	// Ա

	ET_SECTION_OVER_COUNT = 5, // ·ӵ

	ET_READER_ERROR = 6, // վͨ쳣
	ET_CTRL_READER_ERROR = 7, // Ʒվ쳣
	ET_LIGHT_ERROR = 8, // ͨ쳣
	ET_READER_CALL = 9, // վбʶ
	ET_READER_CALL_CANCEL = 10, // ȡзվ

	ET_CARD_LOW_POWER = 11, // 
	ET_CARD_LOW_POWER_SERIOUS = 12, // 

	ET_CARD_OVER_TIME_PERSON = 13, // Ա³ʱmp_card_list_over_time_person
	ET_CARD_OVER_TIME_VEHICLE = 14, // ³ʱmp_card_list_over_time_vehicle
	ET_CARD_AREA_OVER_TIME_PERSON = 15, // Աʱ
	ET_CARD_AREA_OVER_TIME_VEHICLE = 16, // ʱ
	ET_CARD_AREA_LIMIT_PERSON = 17, // Ա
	ET_CARD_AREA_LIMIT_VEHICLE = 18, // 
	ET_CARD_AREA_FORBIDDEN_PERSON = 19,  // Աֹ
	ET_CARD_AREA_FORBIDDEN_VEHICLE = 20, // ֹ
	ET_CARD_OVER_SPEED = 21, // 
	ET_CARD_AREA_OVER_SPEED = 22, // 
	ET_CARD_RUN_THE_RED_LIGHT = 23, // 
	ET_CARD_HELP = 24, // Ա
	ET_CARD_CALLED = 25, // Աѱ
	ET_CARD_PATROL_ERROR = 26, // ԱѲ쳣
	ET_CARD_LOST = 27, // ʶźŶʧ
	ET_CARD_DRIVINGFACE_WARNING_AREA = 28,  // 濿Ԥ澯
	ET_CARD_NEAR_DRIVINGFACE_VEHICLE=29,// Ա澯
	ET_CARD_NEAR_DRIVINGFACE_OVERCOUNT=30,//ԱԱ
	ET_UWB_MORE_CARD = 31,
	ET_CARD_MOTIONLESS=32,
	ET_READER_POWER_BY_BATTERY=33,		//վأ1Ϊع磬0Ϊ繩磬عҪ澯
	ET_VEHICLE_REAR_END=36,				//׷β澯
	ET_COALING_DRIVING_DRIVER=37,		//(ú;)˾복澯
	ET_VEHICLE_NEAR_GEOFAULT=38,		//ϲ澯
	ET_READER_LOCATION_REVERSAL=39,     //߶λ澯
	ET_RUN_RED_LIGHT=40,     //߶λ澯
	CARD_EVENT_COUNT_MAX,
};

enum OBJECT_TYPE // 
{
	OT_MINE = 1, // 
	OT_AREA = 2,  // 
	OT_SECTION = 3, // ·
	OT_DEVICE_READER = 4, // վ
	OT_DEVICE_LIGHT = 5, // ͨ
	OT_DEVICE_ctrl_reader = 6, // Ʒվ
	OT_DEVICE_LED = 7, // led
	OT_DEVICE_SPEAKER = 8, // 
	OT_CARD = 9, // ʶԱ
	OT_DRIVINGFACE_AREA=10,
	OT_UWB_MORE_CARD=11,
};

enum EVENT_STATUS{ // ¼״̬
	ES_START = 0, // ¼ʼ
	ES_DEAL_HELP = 1, // lihongzhen  2017/8/19 Ѵ״̬ 
	ES_END = 100 // ¼
};

enum REQUEST_COUNTS_TYPE{
	REQUEST_ALL = 0,
	REQUEST_ALL_OVER_TIME_PERSON,
	REQUEST_AREA_OVER_TIME_PERSON,
	REQUEST_SPECIAL_ERROR_PERSON,
	REQUEST_ALL_OVER_TIME_VEHICLE,
	REQUEST_AREA_OVER_TIME_VEHICLE,
	REQUEST_ALL_OVER_PERSON,
	REQUEST_AREA_OVER_PERSON,
	REQUEST_ALL_OVER_VEHICLE,
	REQUEST_AREA_OVER_VEHICLE
};

// 澯¼
class YaEvent
{
private:
	INT64 ev_id;
public:

	YaEvent(){};
	YaEvent(INT64 e_id){
		ev_id = e_id;

		obj_id = "";
		cur_time = time(NULL);
		map_id = 0;
		area_id = 0;
		x = 0;
		y = 0;
		limit_value = 0;
		cur_value = 0;
		desc = "";
		landmarkid = 0;
		landmarkdirect = 0;
		landmarkdist = 0;
	};
	~YaEvent(){};
public:
	EVENT_STATUS status; // 澯״̬ʼ

	EVENT_TYPE ev_type; // 澯
	OBJECT_TYPE obj_type; // 澯
	std::string obj_id; // 澯ţ澯ͶӦ澯ΪվֶΪվ
	time_t cur_time; // ǰʱ䣬Ϊ澯¼Ĵʱ䣬״̬Ϊʼʾʼʱ䣬Ϊʱ

	int map_id; // 澯ڵͼ
	int area_id; // 澯
	double x; // λ
	double y;	
	double limit_value; // 澯ֵ
	double cur_value; // ǰֵ
	std::string desc; // 
	int landmarkid; // 澯رλ
	int landmarkdirect;
	int landmarkdist;

	bool is_sent; // ѷ

	INT64 get_id(){return ev_id;};
};

// ƵϢ
class LightCallInfo{
public:
	LightCallInfo(){
		light_id = 0;
		ctrl_type = 0;
		ctrl_color = 0;
		light_state = 0;
		task_id = "";
	}
public:
	int light_id; // Ʊ
	int ctrl_type; // ͣԶֶ
	int ctrl_color; // ʾɫ
	int light_state; // ״̬
	std::string task_id;
};

enum DIRECTION_TYPE{
	NODIRECTORY = 0,
	EAST = 1,
	SOURTH = 2,
	WEST = 3,
	NORTH = 4
};

// ڹ
class VehicleTypeAttRule
{
public:
	VehicleTypeAttRule(int vtid, int pre, int back);
	~VehicleTypeAttRule();

	int vehicle_type_id; // ͱ
	int offset_pre; // ǰƫʱ
	int offset_back; // ƫʱ
	std::vector<int> vecArea; // 

	void Clear();
	void AddArea(int area_id);
};

// ֶƶͼ
class HandUpVehicle
{
public:
	std::string card_id;
	double point_x;
	double point_y;
	int area_id;
};

//ƶվ
class MovingReader{
public:
	MovingReader(std::shared_ptr<Card> pCard,int reader_id){
		this->pVehicleCard = pCard;
		this->moving_reader_id = reader_id;
	};
	MovingReader(){
		this->pVehicleCard = nullptr;
		this->moving_reader_id = 0;
	};
	~MovingReader(){};
public:
	int moving_reader_id;					// ƶվid
	std::shared_ptr<Card> pVehicleCard;		// Ϣ
	CardMap mp_person_card;					// ͳƶվյ˿б

public:
	std::shared_ptr<Card> get_card(){return pVehicleCard;};
	void set_card(std::shared_ptr<Card> pCard){this->pVehicleCard = pCard;};
};

enum HAND_UP_STATUS{ // ֶŲ״̬
	NOT_IN_HANDUP_LIST = 0, // handup list
	IN_HANDUP_LIST_AREA_IN = 1, // handup listУڰ뾶 
	IN_HANDUP_LIST_AREA_OUT = 2 // handup listУڰ뾶
};

#ifdef DEBUG
#define TEST_FROM_FILE 1
#else
#endif // DEBUG

#endif //YASERVER_CLASSDEF_H_
