#ifndef LOG_PROCESS_MODULE
#define LOG_PROCESS_MODULE

#include "log4cpp/Category.hh"
#include "log4cpp/FileAppender.hh"
#include "log4cpp/BasicLayout.hh"
#include "log4cpp/SimpleLayout.hh"
#include <log4cpp/RollingFileAppender.hh>

#ifndef _DEBUG
#pragma comment(lib, "log4cppLIB.lib")
#else
#pragma comment(lib, "log4cppD.lib")
#endif

#define SYS_LOG_INFO        0
#define SYS_LOG_WARNING     1
#define SYS_LOG_ERROR       2

#define LOG_BUF_SIZE        2000

#define ROLLING_LOG_FILE_SIZE       (200*1024*1024)
#define ROLLING_LOG_FILE_NUM        500

#define LOG_FILE_NUM        1
extern log4cpp::Appender *appender[LOG_FILE_NUM];
extern log4cpp::Layout *layout[LOG_FILE_NUM];
extern log4cpp::Category* category[LOG_FILE_NUM];
extern char* log_file_name[LOG_FILE_NUM];
extern char* log_appender_name[LOG_FILE_NUM];
extern char* log_category_name[LOG_FILE_NUM];

extern int log_module_init(void);
extern int debug_print(UINT debugLevel, char* logStr);


#endif
