#include "stdafx.h"
#include "MyLog.h"

MyLog::MyLog(FILE_TYPE type)
{
	flag = false;

	fileType = type;

	curFileCount = 0;
	strExeDir = GetExeDir();
	if (fileType >= 0 && fileType < FILE_TYPE_TOTAL) {
		status = false;
		InitLogConfig();
		flag = true;
	}		
}

MyLog::MyLog(FILE_TYPE type,bool status)
{
	flag = false;

	fileType = type;

	curFileCount = 0;
	this->status = status;
	strExeDir = GetExeDir();

	if (fileType >= 0 && fileType < FILE_TYPE_TOTAL) {
		InitLogConfig();
		flag = true;
	}	
}

MyLog::~MyLog()
{
	//pCategory->shutdown();
}

int MyLog::WriteLog(const std::string msg)
{
	pCategory->info(msg.c_str());

	//־ļСļ
	if (getCurTime() != m_Lasttime)
	{
		m_Lasttime = getCurTime();
		std::string filename = GetFileName();
		SetAppender(filename);
	}

	return 0;
}

int MyLog::WriteLog(const char * pMsg,...)
{
	va_list args;
	char log[1024];
	va_start(args, pMsg);
	vsnprintf_s(log,1024-1,pMsg,args);

	std::string strLog = "";
	strLog = log;
	WriteLog(strLog);

	return 0;
}

int MyLog::test()
{
	bool bRet = false;

	std::string dir = "log/20170603";

	dir = GetFileName();

	for (int i = 0;i < 10;i++) {
		curFileCount++;
		dir = GetFileName();
	}

	dir = "";
	dir = GetExeDir();

	bRet = IsDirExist(dir);
	if (!bRet) {
		CreateDir(dir.c_str());
	}

	return 0;
}

int MyLog::InitLogConfig()
{
	std::string name = my_log_file_name[fileType];
	
	std::string str_category = my_log_file_name[fileType] + "_category";
	m_Lasttime = getCurTime();
	std::string filepath = strExeDir + "log\\" + m_Lasttime + "\\";
	if (!IsDirExist(filepath))
	{
		CreateDir(filepath.c_str());
	}
	std::string filename = filepath + GetFileName();
	pLayout = new log4cpp::PatternLayout();
	/*
	%c category
	%d ڣڿԽһøʽûŰΧ%d{ %H:%M : %S,%l }  %d{ %d %m %Y %H:%M : %S,%l }þڸʽĬϸʽʹáWed Jan 02 02:03 : 55 1980ڵĸʽANSI Cstrftimeеһ¡һʽ%lʾ룬ռʮλ
	%m Ϣ
	%n зƽ̨Ĳͬͬû͸
	%p ȼ
	%r Դlayoutĺ
	%R 1970110ʱʼĿǰΪֹ
	%u ̿ʼĿǰΪֹʱ
	%x NDC
	*/

	//statusfalseʾʱϢ
	//statustrueRAW_SļʱϢļʱϢ
	pLayout->setConversionPattern(log_file_pattern[status]);

	//appender = new log4cpp::FileAppender(name.c_str(), filename.c_str());
	//RollingFileAppender˵
	//ʾÿļֵΪ200M
	//ĸʾļ
	//ʾˢ
	pAppender = new log4cpp::RollingFileAppender(name.c_str(), filename.c_str(),MAX_FILE_SIZE,MAX_BACKUP_COUNTS,true);

	pAppender->setLayout(pLayout);

	pCategory = &(log4cpp::Category::getInstance(str_category.c_str()));
	pCategory->addAppender(pAppender);
	pCategory->setPriority(log4cpp::Priority::INFO);

	return 0;
}

std::string MyLog::GetExeDir()
{
	std::string dir = "";

	TCHAR chpath[MAX_PATH];
	::GetModuleFileName(NULL,chpath, MAX_PATH);
	(_tcsrchr(chpath, _T('\\')))[1] = 0;
	dir = TCHAR2string(chpath);

	return dir;
}

bool MyLog::IsDirExist(std::string path)
{
	bool bRet = false;

	struct _stat fileStat;
	if ((_stat(path.c_str(), &fileStat) == 0) && (fileStat.st_mode & _S_IFDIR))
	{
		bRet = true;
	}

	return bRet;
}

bool MyLog::CreateDir(const char * pDir)
{
	//std::string cmd = "md " + path;
	//system(cmd.c_str());//һļ 
	int i = 0;  
	int iRet;  
	int iLen;  
	char* pszDir;  

	if(NULL == pDir)  
	{  
		return 0;  
	}  

	pszDir = strdup(pDir);  
	iLen = strlen(pszDir);  

	// мĿ¼  
	for (i = 0;i < iLen;i ++)  
	{  
		if (pszDir[i] == '\\' || pszDir[i] == '/')  
		{   
			pszDir[i] = '\0';  

			//,  
			iRet = ACCESS(pszDir,0);  
			if (iRet != 0)  
			{  
				iRet = MKDIR(pszDir);  
				if (iRet != 0)  
				{  
					return false;  
				}   
			}  
			//֧linux,\/  
			pszDir[i] = '/';  
		}   
	}  

	iRet = MKDIR(pszDir);  
	free(pszDir);  
	return true;
}

std::string MyLog::TCHAR2string(TCHAR * tch)
{
	int iLen = WideCharToMultiByte(CP_ACP, 0, tch, -1, NULL, 0, NULL, NULL);

	char* chRtn = new char[iLen * sizeof(char)];

	WideCharToMultiByte(CP_ACP, 0, tch, -1, chRtn, iLen, NULL, NULL);

	std::string str(chRtn);

	return str;
}

std::string MyLog::int2string(int value)
{
	return std::to_string(value);
}

/*
 * ڱ仯Ŀ¼־ 
*/
int MyLog::SetAppender(const char* filename)
{
	std::string name = my_log_file_name[fileType];
	//std::string strFileName = strExeDir + "log/" + filename;
	std::string filepath = strExeDir + "log/" + m_Lasttime + "/";
	if (!IsDirExist(filepath))
	{
		CreateDir(filepath.c_str());
	}
	std::string strFileName = filepath + filename;

	pCategory->removeAppender(pAppender);

	pAppender = new log4cpp::RollingFileAppender(name.c_str(), strFileName.c_str(),MAX_FILE_SIZE,MAX_BACKUP_COUNTS,true);
	//need malloc again 
	pLayout = new log4cpp::PatternLayout();
	pLayout->setConversionPattern(log_file_pattern[status]);

	pAppender->setLayout(pLayout);

	pCategory->setAppender(pAppender);
	return 0;
}

int MyLog::SetAppender(std::string filename)
{
	SetAppender(filename.c_str());
	return 0;
}

int MyLog::SetLayout(bool status)
{
	if (status)
	{
		pLayout->setConversionPattern(log_file_pattern[1]);
	} 
	else
	{
		pLayout->setConversionPattern(log_file_pattern[0]);
	}
	
	return 0;
}

long MyLog::GetFileSize()
{
	if (curFileName == "") {
		return 0;
	}

	struct _stat info;
	_stat(curFileName.c_str(), &info);
	long size = info.st_size;

	return size;
}
std::string MyLog::getCurTime()
{
	std::string stringDate;
	char chDate[255] = {0};
	time_t today;
	tm* t = new tm;

	time(&today);
	localtime_s(t, &today);

	strftime(chDate, 255, "%Y%m%d", t);
	stringDate = chDate;
	if (t) {
		delete t;
	}
	return stringDate;
}
std::string MyLog::GetFileName()
{
	//־ļʽΪ +  + ׺.log
	std::string stringDate = "";
	stringDate = getCurTime();
	//curFileName = my_log_file_name[fileType] + "_" + curDate + "_" + int2string(curFileCount) + ".log";
	curFileName = my_log_file_name[fileType] + "_" + stringDate + ".log";

	return curFileName;
}